import "./DBStorableDataSet";
import "../../core/dataset/ITreeDataSet";
import "../../core/dataset/TreeDataSet";
import "../../java/util/ArrayList";
var qx = require("xlsys-qx");

qx.Class.define("xlsys.base.dataset.DBSTreeDataSet",
{
	extend : xlsys.base.dataset.DBStorableDataSet,
	implement : [xlsys.core.dataset.ITreeDataSet],
	
	construct : function(dataBase, selectBean, tableName)
	{
		this.base(arguments, dataBase, selectBean, tableName);
	},
	
	members : 
	{
		treeColName : null,
		
		setTreeColumn : function(colNameOrColAt)
		{
			var treeColName = null;
			if(qx.lang.Type.isNumber(colNameOrColAt)) treeColName = this.getColName(colNameOrColAt);
			else treeColName = colNameOrColAt;
			this.treeColName = treeColName;
			var colAt = this.getColAt(treeColName);
			this.checkColRegion(colAt);
			xlsys.core.dataset.TreeDataSet._setTreeColumn(this, colAt);
		},
		
		sort : function()
		{
			if(this.treeColName!=null) this.setTreeColumn(this.treeColName);
		},
		
		getTreeColumn : function()
		{
			return this.treeColName;
		},
		
		getTreeColAt : function()
		{
			return this.getColAt(this.treeColName);
		},
		
		getRootRows : function()
		{
			return xlsys.core.dataset.TreeDataSet._getRootRows(this);
		},

		getChildren : function(rowOrRowAt)
		{
			var rowAt = null;
			if(qx.lang.Type.isNumber(rowOrRowAt)) rowAt = rowOrRowAt;
			else rowAt = this.getRowAt(rowOrRowAt);
			this.checkRowRegion(rowAt);
			return xlsys.core.dataset.TreeDataSet._getChildren(this, rowAt);
		},

		getAllChildren : function(rowOrRowAt)
		{
			var rowAt = null;
			if(qx.lang.Type.isNumber(rowOrRowAt)) rowAt = rowOrRowAt;
			else rowAt = this.getRowAt(rowOrRowAt);
			this.checkRowRegion(rowAt);
			return xlsys.core.dataset.TreeDataSet._getAllChildren(this, rowAt);
		},

		getParentRow : function(rowOrRowAt)
		{
			var rowAt = null;
			if(qx.lang.Type.isNumber(rowOrRowAt)) rowAt = rowOrRowAt;
			else rowAt = this.getRowAt(rowOrRowAt);
			this.checkRowRegion(rowAt);
			return xlsys.core.dataset.TreeDataSet._getParentRow(this, rowAt);
		},

		getAllParent : function(rowOrRowAt)
		{
			var rowAt = null;
			if(qx.lang.Type.isNumber(rowOrRowAt)) rowAt = rowOrRowAt;
			else rowAt = this.getRowAt(rowOrRowAt);
			this.checkRowRegion(rowAt);
			return xlsys.core.dataset.TreeDataSet._getAllParent(this, rowAt);
		},

		removeRow : function(rowOrRowAt, removeChildren)
		{
			if(removeChildren==null) removeChildren = false;
			var rowAt = null;
			if(qx.lang.Type.isNumber(rowOrRowAt)) rowAt = rowOrRowAt;
			else rowAt = this.getRowAt(rowOrRowAt);
			this.checkRowRegion(rowAt);
			var removedRows = new xlsys.java.util.ArrayList();
			if(removeChildren)
			{
				// 删除子行
				var children = this.getAllChildren(rowAt);
				removedRows.addAll(children);
				for(var i=children.size()-1;i>=0;--i) this.base(arguments, children.get(i));
			}
			removedRows.add(this.base(arguments, rowAt));
			if(arguments.length==1)
			{
				if(removedRows.isEmpty()) return null;
				else return removedRows.get(0);
			}
			return removedRows;
		},
		
		asyncRemoveRow : async function(rowOrRowAt, removeChildren)
		{
			return this.removeRow(rowOrRowAt, removeChildren);
		}
	}
});