import "../../../core/io/net/AbstractClientTransfer";
import "../../../core/env/Environment";
import "../../../client/base/ClientBase";
import "../../../core/util/ReflectUtil";
var qx = require("xlsys-qx");

qx.Class.define("xlsys.base.io.net.HttpClientTransfer",
{
	type : "abstract",
	extend : xlsys.core.io.net.AbstractClientTransfer,

	properties : 
	{
		serverIp : 
		{
			init : "",
			apply : "_applyUrl",
			check : "String"
		},
		
		serverPort : 
		{
			init : 80,
			apply : "_applyUrl",
			check : "Number"
		},
		
		timeout : 
		{
			init : 0,
			check : "Number"
		},
		
		path : 
		{
			init : "",
			apply : "_applyUrl",
			check : "String"
		}
	},
	
	statics : 
	{
		getInstance : function(serverIp, serverPort, timeout, path)
		{
			var env = xlsys.core.env.Environment.getInstance();
			var transferClassName = env.getString(xlsys.client.base.ClientBase.ENV_TRANSFER_CLASS);
			var clientTransfer = xlsys.core.util.ReflectUtil.newInstance(transferClassName);
			clientTransfer.setServerIp(serverIp);
			clientTransfer.setServerPort(serverPort);
			clientTransfer.setTimeout(timeout);
			clientTransfer.setPath(path);
			return clientTransfer;
		}
	},
	
	construct : function()
	{
		this.base(arguments);
	},
	
	members : 
	{
		_url : null,
		
		_applyUrl : function()
		{
			var serverIp = this.getServerIp();
			var serverPort = this.getServerPort();
			var path = this.getPath();
			this._url = "http://" + serverIp + ":" + serverPort + path;
		},
		
		post : async function(inObj)
		{
			return new Promise(resolve=>this.asynPost(inObj, resolve));
		},
		
		asynPost : function(inObj, callback)
		{
			throw new Error("Abstract method call");
		}
	}
});
