import "../../../core/buffer/EnvBuffer";
import "./IClientBaseBuffer";
import "./MClientBaseBuffer";
var qx = require("xlsys-qx");

qx.Class.define("xlsys.client.base.buffer.ClientBaseBuffer", 
{
	type : "abstract",
	extend : xlsys.core.buffer.EnvBuffer,
	implement : [xlsys.client.base.buffer.IClientBaseBuffer],
	include : [xlsys.client.base.buffer.MClientBaseBuffer],
	
	construct : function()
	{
		this.base(arguments);
	},
	
	members : 
	{
		getStorageObject : async function(envId, bufferName)
		{
			throw new Error("Abstract method call");
		},
		
		isBufferComplete : async function(envId, bufferName)
		{
			throw new Error("Abstract method call");
		},
		
		reloadDataDirectly : async function(envId, bufferName, paramMap, forceLoad)
		{
			throw new Error("Abstract method call");
		},
		
		loadDataFromStorageObject : async function(envId, bufferName, storageObj)
		{
			throw new Error("Abstract method call");
		},
		
		doGetBufferData : async function(envId, bufferName, paramMap)
		{
			throw new Error("Abstract method call");
		},
		
		getBufferData : async function(envId, bufferName, paramMap)
		{
			return await this._getBufferData(envId, bufferName, paramMap);
		},
		
		updateCurrentVersion : async function(envId, bufferName)
		{
			return await this._updateCurrentVersion(envId, bufferName);
		},
		
		getCurrentVersion : async function(envId, bufferName)
		{
			return await this._getCurrentVersion(envId, bufferName);
		},
		
		saveDataToLocalStorage : async function(envId, bufferName, storageObject)
		{
			return await this._saveDataToLocalStorage(envId, bufferName, storageObject);
		},
		
		reloadAllData : async function(envId, bufferName, forceLoad)
		{
			return await this._reloadAllData(envId, bufferName, forceLoad);
		},
		
		reloadData : async function(envId, bufferName, paramMap, forceLoad)
		{
			return await this._reloadData(envId, bufferName, paramMap, forceLoad);
		},
		
		reloadDataFromLocalStorage : async function(envId, bufferName)
		{
			return await this._reloadDataFromLocalStorage(envId, bufferName);
		},
		
		getLocalStorageVersion : async function(envId, bufferName)
		{
			return await this._getLocalStorageVersion(envId, bufferName);
		}
	}
});