import "../../../core/buffer/EnvBuffer";
var qx = require("xlsys-qx");

qx.Class.define("xlsys.client.base.buffer.UnstorageBuffer",
{
	type : "abstract",
	extend : xlsys.core.buffer.EnvBuffer,

	members : 
	{
		reloadDataDirectly : async function(envId, bufferName, paramMap, forceLoad)
		{
			throw new Error("Abstract method call");
		},
		
		getBufferData : async function(envId, bufferName, paramMap)
		{
			throw new Error("Abstract method call");
		},
		
		reloadAllData : async function(envId, bufferName, forceLoad)
		{
			throw new Error("Abstract method call");
		},
		
		reloadData : async function(envId, bufferName, paramMap, forceLoad)
		{
			throw new Error("Abstract method call");
		},
		
		getStorageObject : async function(envId, bufferName)
		{
			return null;
		},

		isBufferComplete : async function(envId, bufferName)
		{
			return false;
		},

		loadDataFromStorageObject : async function(envId, bufferName, storageObj)
		{
			return false;
		},

		updateCurrentVersion : async function(envId, bufferName)
		{
			return -1;
		},

		getCurrentVersion : async function(envId, bufferName)
		{
			return -1;
		},

		saveDataToLocalStorage : async function(envId, bufferName, storageObject)
		{
			return false;
		},

		reloadDataFromLocalStorage : async function(envId, bufferName)
		{
			return false;
		},

		getLocalStorageVersion : async function(envId, bufferName)
		{
			return -1;
		}
	}
});
