import "./IClientStorage";
import "../../../core/env/Environment";
import "../ClientBase";
import "../../../core/util/ReflectUtil";
var qx = require("xlsys-qx");

qx.Class.define("xlsys.client.base.io.ClientStorage", 
{
	type : "abstract",
	extend : qx.core.Object,
	implement : [xlsys.client.base.io.IClientStorage],
	
	statics : 
	{
		_storage : null,
		
		getInstance : function()
		{
			if(this._storage==null)
			{
				var env = xlsys.core.env.Environment.getInstance();
				var storageClassName = env.getString(xlsys.client.base.ClientBase.ENV_STORAGE_CLASS);
				if(storageClassName!=null) this._storage = xlsys.core.util.ReflectUtil.newInstance(storageClassName);
			}
			return this._storage;
		}
	},
	
	members : 
	{
		setItem : async function(groupName, key, value)
		{
			throw new Error("Abstract method call");
		},
		
		getItem : async function(groupName, key)
		{
			throw new Error("Abstract method call");
		}
	}
});