import "../session/SessionManager";
import "../../../core/session/Session";
import "../../../core/Core";
import "../../../core/util/ObjectUtil";
import "../../../core/env/Environment";
import "../ClientBase";
import "../../../base/io/net/HttpClientTransfer";
import "../../../core/service/Task";
import "../../../base/Base";
var qx = require("xlsys-qx");

qx.Class.define("xlsys.client.base.util.RequestUtil",
{
	type : "static",

	statics : 
	{
		_clientTransfer : null,
		
		simpleRequest : async function(command, inObj)
		{
			var session = xlsys.client.base.session.SessionManager.getInstance().getCurrentSession();
			if(session==null)
			{
				session = new xlsys.core.session.Session();
				session.setAttribute(xlsys.core.Core.SESSION_ENV_ID, xlsys.core.util.ObjectUtil.objectToInt(xlsys.core.env.Environment.getInstance().getString(xlsys.client.base.ClientBase.ENV_ENV_ID)));
			}
			return await this.requestCommand(command, session, inObj);
		},
		
		/**
		 * requestCommand(command, session, inObj);
		 * requestCommand(command, session, inObj, wholeSession);
		 * requestCommand(command, session, inObj, ...sessionAttrs);
		 */
		requestCommand : async function(command, session, inObj)
		{
			if(arguments.length>3&&qx.lang.Type.isString(arguments[3]))
			{
				// requestCommand(command, session, inObj, ...sessionAttrs);
				var transSession = new xlsys.core.session.Session(session.getSessionId());
				for(var i=3;i<arguments.length;++i)
				{
					transSession.setAttribute(arguments[i], session.getAttribute(arguments[i]));
				}
				return await this.__requestCommand(command, session, inObj, transSession);
			}
			else
			{
				// requestCommand(command, session, inObj);
				// requestCommand(command, session, inObj, wholeSession);
				var transSession = session;
				var wholeSession = false;
				if(arguments.length>3) wholeSession = arguments[3]; 
				// 如果session不是默认id, 则只发送增量
				if(!wholeSession&&session!=null&&session.getSessionId()!=xlsys.core.session.Session.DEFAULT_ID)
				{
					var cloneSession = new xlsys.core.session.Session(session.getSessionId());
					cloneSession.setSessionType(xlsys.core.session.Session.TYPE_INCREMENTAL);
					var changedKeys = session.getChangedEnvKeys().toArray();
					for(var i in changedKeys)
					{
						var changedKey = changedKeys[i];
						cloneSession.setAttribute(changedKey, session.getAttribute(changedKey));
					}
					session.getChangedEnvKeys().clear();
					transSession = cloneSession;
				}
				return await this.__requestCommand(command, session, inObj, transSession);
			}
		},
		
		__requestCommand : async function(command, srcSession, inObj, transSession)
		{
			if(this._clientTransfer==null)
			{
				var env = xlsys.core.env.Environment.getInstance();
				var serverIp = env.getString(xlsys.client.base.ClientBase.ENV_TRANSFER_SERVERIP);
				var serverPort = xlsys.core.util.ObjectUtil.objectToInt(env.getString(xlsys.client.base.ClientBase.ENV_TRANSFER_SERVERPORT));
				var timeout = xlsys.core.util.ObjectUtil.objectToInt(env.getString(xlsys.base.Base.ENV_REQUEST_TIME_OUT));
				var path = env.getString(xlsys.client.base.ClientBase.ENV_TRANSFER_PATH);
				this._clientTransfer = xlsys.base.io.net.HttpClientTransfer.getInstance(serverIp, serverPort, timeout, path);
			}
			var task = new xlsys.core.service.Task(xlsys.base.Base.TASK_TYPE_REQUEST);
			var taskParams = task.getTaskParams();
			taskParams.put(xlsys.base.Base.TASK_PARAM_COMMAND, command);
			taskParams.put(xlsys.base.Base.TASK_PARAM_SESSION, transSession);
			taskParams.put(xlsys.base.Base.TASK_PARAM_IN_OBJECT, inObj);
			var ret = await this._clientTransfer.post(task);
			// 判断服务端是否在请求完整的session
			if(xlsys.base.Base.RESPONSE_WHOLE_SESSION==ret) ret = await this.__requestCommand(command, srcSession, inObj, srcSession);
			return ret;
		}
	}
});
