import "../../../base/buffer/IModelBufferDelegate";
import "../../../base/util/RequestUtil";
import "../../../../business/core/BusinessCore";
import "../../../../java/util/LinkedHashMap";
var qx = require("xlsys-qx");

qx.Class.define("xlsys.client.business.core.buffer.CBCModelBufferDelegate",
{
	extend : qx.core.Object,
	implement : [xlsys.client.base.buffer.IModelBufferDelegate],
	
	construct : function(bufferName, keyColumn)
	{
		this.bufferName = bufferName;
		this.keyColumn = keyColumn;
	},
	
	members : 
	{
		bufferName : null,
		keyColumn : null,
		
		getAllCount : async function(dataBase)
		{
			return await xlsys.client.base.util.RequestUtil.simpleRequest(xlsys.business.core.BusinessCore.COMMAND_GET_MODEL_COUNT, this.bufferName);
		},
		
		createAllModels : async function(dataBase)
		{
			var allModelList = await xlsys.client.base.util.RequestUtil.simpleRequest(xlsys.business.core.BusinessCore.COMMAND_GET_ALL_MODEL, this.bufferName);
			var modelMap = new xlsys.java.util.LinkedHashMap();
			for(var i=0;i<allModelList.size();++i)
			{
				var model = allModelList.get(i);
				modelMap.put(model[this.keyColumn], model);
			}
			return modelMap;
		},
		
		createModel : async function(dataBase, key)
		{
			var arr = new Array();
			arr.push(this.bufferName);
			arr.push(key);
			return await xlsys.client.base.util.RequestUtil.simpleRequest(xlsys.business.core.BusinessCore.COMMAND_GET_MODEL, arr);
		}
	}
});