import "../../../../business/core/BusinessCore";
import "../../../../core/Core";
import "../../../../core/session/ISession";
import "../buffer/CBCModelBuffer";
import "../../../../java/util/HashMap";
import "../../../../core/util/SqlUtil";
var qx = require("xlsys-qx");

qx.Class.define("xlsys.client.business.core.util.CBCCommonUtil",
{
	type : "static",
	
	statics :
	{
		/**
		 * isAdmin(session);
		 * isAdmin(pstIds);
		 */
		isAdmin : function(sessionOrPstIds)
		{
			let pstIds = null;
			if(qx.lang.Type.isString(sessionOrPstIds)) pstIds = sessionOrPstIds;
			else pstIds = sessionOrPstIds.getAttribute(xlsys.business.core.BusinessCore.SESSION_PST_ID);
			let isadmin = false;
			if(pstIds!=null)
			{
				let pstIdArr = pstIds.split(xlsys.core.Core.CN_SEPARATOR);
				for(let i in pstIdArr)
				{
					if(xlsys.business.core.BusinessCore.DEFAULT_ADMIN_CODE==pstIdArr[i])
					{
						isadmin = true;
						break;
					}
				}
			}
			return isadmin;
		},
		
		/**
		 * hasRight(targetRightType, session, rightValue);
		 * hasRight(targetRm, session, rightValue);
		 * hasRight(targetRm, macroMap, rightValue);
		 */
		hasRight : async function()
		{
			if(arguments.length!=3) return false;
			var targetRightType = null;
			var targetRm = null;
			var session = null;
			var macroMap = null;
			var rightValue = null;
			if(qx.lang.Type.isNumber(arguments[0]))
			{
				// hasRight(targetRightType, session, rightValue);
				targetRightType = arguments[0];
				session = arguments[1];
				rightValue = arguments[2];
			}
			else if(qx.Class.implementsInterface(arguments[1], xlsys.core.session.ISession))
			{
				// hasRight(targetRm, session, rightValue);
				targetRm = arguments[0];
				session = arguments[1];
				rightValue = arguments[2];
			}
			else
			{
				// hasRight(targetRm, macroMap, rightValue);
				targetRm = arguments[0];
				macroMap = arguments[1];
				rightValue = arguments[2];
			}
			if(targetRm==null)
			{
				targetRm = await xlsys.client.business.core.buffer.CBCModelBuffer.getInstance().getModel(xlsys.business.core.BusinessCore.BUFFER_RIGHT_MODEL, session, targetRightType);
			}
			if(macroMap==null)
			{
				macroMap = new xlsys.java.util.HashMap();
				var rmList = await xlsys.client.business.core.buffer.CBCModelBuffer.getInstance().getAllModels(xlsys.business.core.BusinessCore.BUFFER_RIGHT_MODEL, session);
				for(var i=0;i<rmList.size();++i)
				{
					var rm = rmList.get(i);
					macroMap.put(rm.getRelationcolumn(), session.getAttribute(rm.getSessionkey()));
				}
			}
			return this.rightValueMatched(macroMap.get(targetRm.getRelationcolumn()), rightValue, macroMap);
		},
		
		rightValueMatched : function(curValues, toMatchValue, macroMap)
		{
			if(curValues==null||toMatchValue==null) return false;
			var matched = false;
			var curValueArr = curValues.split(xlsys.core.Core.CN_SEPARATOR);
			var toMatchArr = xlsys.core.util.SqlUtil.replaceExpression(toMatchValue, macroMap);
			var regex = new RegExp("");
			for(var i=0;i<toMatchArr.length;++i)
			{
				var toMatch = toMatchArr[i];
				toMatch = toMatch.replace(/%/g, ".*");
				toMatch = toMatch.replace(/_/g, ".");
				toMatch = "^(" + toMatch + ")$";
				for(var j=0;j<curValueArr.length;++j)
				{
					var curValue = curValueArr[j];
					regex.compile(toMatch);
					if(regex.test(curValue))
					{
						matched = true;
						break;
					}
				}
				if(matched) break;
			}
			return matched;
		}
	}
});