import "./IBuffer";
import "../../java/util/HashMap";
import "../../java/util/LinkedHashMap";
import "../util/ReflectUtil";
var qx = require("xlsys-qx");

qx.Class.define("xlsys.core.buffer.EnvBuffer",
{
	type : "abstract",
	extend : qx.core.Object,
	implement : [xlsys.core.buffer.IBuffer],
	
	construct : function()
	{
		this.allEnvBufferMap = new xlsys.java.util.HashMap();
	},
	
	members : 
	{
		allEnvBufferMap : null,
		
		/**
		 * getBufferMap(envId, bufferName);
		 * getBufferMap(envId, bufferName, mapClassName);
		 */
		getBufferMap : function(envId, bufferName, mapClassName)
		{
			var envBufferMap = this.allEnvBufferMap.get(envId);
			if(envBufferMap==null)
			{
				envBufferMap = new xlsys.java.util.HashMap();
				this.allEnvBufferMap.put(envId, envBufferMap);
			}
			var bufferMap = envBufferMap.get(bufferName);
			if(bufferMap==null)
			{
				if(mapClassName==null) bufferMap = new xlsys.java.util.LinkedHashMap();
				else
				{
					try
					{
						bufferMap = xlsys.core.util.ReflectUtil.newInstance(mapClassName);
					}
					catch(error)
					{
						bufferMap = new xlsys.java.util.LinkedHashMap();
					}
				}
				envBufferMap.put(bufferName, bufferMap);
			}
			return bufferMap;
		}
	}
});
