var qx = require("xlsys-qx");

qx.Interface.define("xlsys.core.database.IDataBase",
{
	statics : 
	{
		BUFFER_KEY_TABLE_NAME : "_BUFFER_KEY_TABLE_NAME"
	},
	
	members:
	{
		getDataBaseId : function() {},
		
		getTableInfo : async function(tableName, useBuffer) {this.assertArgumentsCount(arguments, 2, 2);},
		
		getAllTableBaseInfo : async function(useBuffer) {this.assertArgumentsCount(arguments, 1, 1);},
		
		getResultCount : async function(paramBean) {this.assertArgumentsCount(arguments, 1, 1);},
		
		/**
		 * sqlSelectAsOneValue(selectSql);
		 * sqlSelectAsOneValue(paramBean);
		 */
		sqlSelectAsOneValue : async function(sqlOrPb) {this.assertArgumentsCount(arguments, 1, 1);},
		
		/**
		 * sqlSelect(selectSql);
		 * sqlSelect(paramBean);
		 * sqlSelect(paramBean, tryTableInfo);
		 * sqlSelect(paramBean, beginRowNum, endRowNum);
		 * sqlSelect(paramBean, sortColMap, beginRowNum, endRowNum);
		 */
		sqlSelect : async function() {this.assertArgumentsCount(arguments, 1, 4);},
		
		/**
		 * sqlExecute(executeSql);
		 * sqlExecute(executeBean);
		 * sqlExecute(sqlBeanList);
		 * sqlExecute(paramBean);
		 */
		sqlExecute : async function(param) {this.assertArgumentsCount(arguments, 1, 1);},
		
		disableConstraint : async function(tableName, constraintName) {this.assertArgumentsCount(arguments, 2, 2);},
		
		enableConstraint : async function(tableName, constraintName) {this.assertArgumentsCount(arguments, 2, 2);},
		
		getLowerFunc : async function(srcExp) {this.assertArgumentsCount(arguments, 1, 1);},
		
		getUpperFunc : async function(srcExp) {this.assertArgumentsCount(arguments, 1, 1);},
		
		getByteLengthFunc : async function(srcExp) {this.assertArgumentsCount(arguments, 1, 1);},
		
		/**
		 * getSubStringFunc(srcExp, begin);
		 * getSubStringFunc(srcExp, begin, end);
		 */
		getSubStringFunc : async function(srcExp, begin) {this.assertArgumentsCount(arguments, 2, 3);},

		getToDateFunc : async function(date) {this.assertArgumentsCount(arguments, 1, 1);},

		getDateFormatFunc : async function(srcExp, format) {this.assertArgumentsCount(arguments, 2, 2);},
		
		getSplitedParamBean : async function(paramBean, beginRowNum, endRowNum) {this.assertArgumentsCount(arguments, 3, 3);},
		
		commit : async function() {},
		
		rollback : async function() {},

		setAutoCommit : async function(autoCommit) {this.assertArgumentsCount(arguments, 1, 1);},
		
		getAutoCommit : function() {},
		
		close : async function() {},
		
		isClose : function() {}
	}
});