import "../../java/io/Serializable";
import "./IDataSetColumn";
var qx = require("xlsys-qx");

/**
 * 数据集列
 */
qx.Class.define("xlsys.core.dataset.DataSetColumn",
{
	extend : xlsys.java.io.Serializable,
	implement : [xlsys.core.dataset.IDataSetColumn],
	
	construct: function()
	{
		this.columnName = null;
		this.javaClass = null;
		this.precision = null;
		this.scale = null;
		this.nullAble = null;
	},
	
	members :
	{
		columnName : null,
		javaClass : null,
		precision : null,
		scale : null,
		nullAble : null,
		
		getSerializableMembers : function()
		{
			var arr = new Array();
			arr.push("columnName");
			arr.push("javaClass");
			arr.push("precision");
			arr.push("scale");
			arr.push("nullAble");
			return arr;
		},
		
		getColumnName : function()
		{
			return this.columnName;
		},

		setColumnName : function(columnName)
		{
			this.columnName = columnName;
		},

		getJavaClass : function()
		{
			return this.javaClass;
		},

		setJavaClass : function(javaClass)
		{
			this.javaClass = javaClass;
		},

		getPrecision : function()
		{
			return this.precision;
		},

		setPrecision : function(precision)
		{
			this.precision = precision;
		},

		getScale : function()
		{
			return this.scale;
		},

		setScale : function(scale)
		{
			this.scale = scale;
		},

		isNullAble : function()
		{
			return this.nullAble;
		},

		setNullAble : function(nullAble)
		{
			this.nullAble = nullAble;
		},

		cloneOf : function(anotherCol)
		{
			if(anotherCol!=null)
			{
				var fieldArr = anotherCol.getSerializableMembers();
				for(var i in fieldArr)
				{
					var field = fieldArr[i];
					if(field in this) this[field] = anotherCol[field];
				}
			}
		}
	}
});