import "../IRefreshable";
var qx = require("xlsys-qx");

/**
 * 数据集接口
 */
qx.Interface.define("xlsys.core.dataset.IDataSet",
{
	extend : [xlsys.core.IRefreshable],
	
	members:
	{
		/**
		 * setEventLock(lock);
		 * setEventLock(eventName, lock);
		 */
		setEventLock : function(eventName, lock) {this.assertArgumentsCount(arguments, 1, 2);},
		
		isEventLock : function(eventName) {this.assertArgumentsCount(arguments, 1, 1);},
		
		setRowClassName : function(rowClassName) {this.assertArgumentsCount(arguments, 1, 1);},
		
		setColClassName : function(colClassName) {this.assertArgumentsCount(arguments, 1, 1);},
		
		setCellClassName : function(cellClassName) {this.assertArgumentsCount(arguments, 1, 1);},
		
		getRowClassName : function() {},
		
		getColClassName : function() {},
		
		getCellClassName : function() {},
		
		getCursor : function() {},
		
		getRowCursor : function() {},
		
		getColCursor : function() {},
		
		/**
		 * gotoRow(rowAt);
		 * gotoRow(row);
		 */
		gotoRow : function(rowOrRowAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		/**
		 * gotoCol(colAt);
		 * gotoCol(col);
		 */
		gotoCol : function(colOrColAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		/**
		 * gotoCell(row, colAt);
		 * gotoCell(row, col);
		 * gotoCell(rowAt, col);
		 * gotoCell(rowAt, colAt);
		 */
		gotoCell : function(rowOrRowAt, colOrColAt) {this.assertArgumentsCount(arguments, 2, 2);},
		
		/**
		 * getRow();
		 * getRow(rowAt);
		 */
		getRow : function() {this.assertArgumentsCount(arguments, 0, 1);},

		/**
		 * getColumn();
		 * getColumn(colAt);
		 * getColumn(colName);
		 */
		getColumn : function() {this.assertArgumentsCount(arguments, 0, 1);},
		
		/**
		 * getValue();
		 * getValue(colAt);
		 * getValue(colName);
		 * getValue(row, colAt);
		 * getValue(row, colName);
		 * getValue(rowAt, colName);
		 * getValue(rowAt, colAt);
		 */
		getValue : function() {this.assertArgumentsCount(arguments, 0, 2);},
		
		/**
		 * asyncGetValue();
		 * asyncGetValue(colAt);
		 * asyncGetValue(colName);
		 * asyncGetValue(row, colAt);
		 * asyncGetValue(row, colName);
		 * asyncGetValue(rowAt, colName);
		 * asyncGetValue(rowAt, colAt);
		 */
		asyncGetValue : async function() {this.assertArgumentsCount(arguments, 0, 2);},
		
		/**
		 * setValue(value);
		 * setValue(colName, value);
		 * setValue(colAt, value);
		 * setValue(row, colName, value);
		 * setValue(row, colAt, value);
		 * setValue(rowAt, colName, value);
		 * setValue(rowAt, colAt, value);
		 */
		setValue : function() {this.assertArgumentsCount(arguments, 1, 3);},
		
		/**
		 * asyncSetValue(value);
		 * asyncSetValue(colName, value);
		 * asyncSetValue(colAt, value);
		 * asyncSetValue(row, colName, value);
		 * asyncSetValue(row, colAt, value);
		 * asyncSetValue(rowAt, colName, value);
		 * asyncSetValue(rowAt, colAt, value);
		 */
		asyncSetValue : async function() {this.assertArgumentsCount(arguments, 1, 3);},
		
		getRows : function() {},
		
		_getFactRows : function() {},
		
		getCols : function() {},
		
		_getFactCols : function() {},
		
		getColName : function(colAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		getRowAt : function(row) {this.assertArgumentsCount(arguments, 1, 1);},
		
		/**
		 * getColAt(col);
		 * getColAt(colName);
		 */
		getColAt : function(colOrColName) {this.assertArgumentsCount(arguments, 1, 1);},
		
		/**
		 * createCol();
		 * createCol(index);
		 */
		createCol : function() {this.assertArgumentsCount(arguments, 0, 1);},

		/**
		 * addCol(col);
		 * addCol(index, col);
		 */
		addCol : function() {this.assertArgumentsCount(arguments, 1, 2);},
		
		/**
		 * removeCol(col);
		 * removeCol(colAt);
		 */
		removeCol : function(colOrColAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		/**
		 * createRow();
		 * createRow(index);
		 */
		createRow : function() {this.assertArgumentsCount(arguments, 0, 1);},
		
		/**
		 * addRow(row);
		 * addRow(index, row);
		 */
		addRow : function() {this.assertArgumentsCount(arguments, 1, 2);},
		
		/**
		 * removeRow(row);
		 * removeRow(rowAt);
		 */
		removeRow : function(rowOrRowAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		/**
		 * asyncRemoveRow(row);
		 * asyncRemoveRow(rowAt);
		 */
		asyncRemoveRow : async function(rowOrRowAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		clearRows : function() {},
		
		getRowCount : function() {},
		
		getColCount : function() {},
		
		cloneOf : function(anotherDataSet) {this.assertArgumentsCount(arguments, 1, 1);}
	}
});