import "./IDataSet";
import "../ISortable";
var qx = require("xlsys-qx");

/**
 * 支持树形结构的数据集接口
 */
qx.Interface.define("xlsys.core.dataset.ITreeDataSet",
{
	extend : [xlsys.core.dataset.IDataSet, xlsys.core.ISortable],
	
	members :
	{
		/**
		 * setTreeColumn(treeColName);
		 * setTreeColumn(treeColAt);
		 */
		setTreeColumn : function(colNameOrColAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		getTreeColumn : function() {},

		getTreeColAt : function() {},
		
		getRootRows : function() {},
		
		/**
		 * getChildren(row);
		 * getChildren(rowAt);
		 */
		getChildren : function(rowOrRowAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		/**
		 * getAllChildren(row);
		 * getAllChildren(rowAt);
		 * 
		 */
		getAllChildren : function(rowOrRowAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		/**
		 * getParentRow(row);
		 * getParentRow(rowAt);
		 */
		getParentRow : function(rowOrRowAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		/**
		 * getAllParent(row);
		 * getAllParent(rowAt);
		 */
		getAllParent : function(rowOrRowAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		/**
		 * removeRow(row, removeChildren);
		 * removeRow(rowAt, removeChildren);
		 * 新增参数, 但是接口不能覆盖定义
		 */
		// removeRow : function(rowOrRowAt, removeChildren) {this.assertArgumentsCount(arguments, 1, 2);},
		
		/**
		 * asyncRemoveRow(row, removeChildren);
		 * asyncRemoveRow(rowAt, removeChildren);
		 */
		asyncRemoveRow : async function(rowOrRowAt, removeChildren) {this.assertArgumentsCount(arguments, 1, 2);}
	}
});