import "../../java/lang/StringBuilder";
import "../util/ObjectUtil";
import "./ILog";
import "./Log";
var qx = require("xlsys-qx");

qx.Class.define("xlsys.core.log.ConsoleLog", 
{
	extend : xlsys.core.log.Log,
	
	construct: function()
	{
		this.base(arguments);
		this.__sb = new xlsys.java.lang.StringBuilder();
	},
	
	members : 
	{
		__sb : null,
		
		write : function(level, content)
		{
			var str = xlsys.core.util.ObjectUtil.objectToString(content);
			if(str==null) return 0;
			if(qx.lang.String.endsWith(str, "\n"))
			{
				this.__sb.append(str.substr(0, str.length-1));
				var logStr = this.__sb.toString();
				if(xlsys.core.log.ILog.LOG_LEVEL_DEBUG<=level) console.info(logStr);
				else if(xlsys.core.log.ILog.LOG_LEVEL_INFO<=level) console.info(logStr);
				else if(xlsys.core.log.ILog.LOG_LEVEL_WARN<=level) console.warn(logStr);
				else if(xlsys.core.log.ILog.LOG_LEVEL_ERROR<=level) console.error(logStr);
				else if(xlsys.core.log.ILog.LOG_LEVEL_FATAL<=level) console.error(logStr);
				delete this.__sb;
				this.__sb = new xlsys.java.lang.StringBuilder();
			}
			else this.__sb.append(str);
			return str.length;
		},

		close : function() {}
	}
});
