import "./IModel";
import "../../java/io/Serializable";
import "../../java/util/LinkedHashMap";
import "../../java/util/ArrayList";
var qx = require("xlsys-qx");

qx.Class.define("xlsys.core.model.XmlModel",
{
	extend : xlsys.java.io.Serializable,
	implement : [xlsys.core.model.IModel],
	
	construct : function(name, text)
	{
		this.name = name;
		this.text = text;
	},
	
	members : 
	{
		name : null,
		text : null,
		parent : null,
		attribute : null,
		children : null,
		
		getSerializableMembers : function()
		{
			var arr = new Array();
			arr.push("name");
			arr.push("text");
			arr.push("parent");
			arr.push("attribute");
			arr.push("children");
			return arr;
		},
		
		addAttribute : function(attrName, attrValue)
		{
			if(this.attribute==null) this.attribute = new xlsys.java.util.LinkedHashMap();
			this.attribute.put(attrName, attrValue);
		},
		
		addChild : function(child)
		{
			if(this.children==null) this.children = new xlsys.java.util.ArrayList();
			this.children.add(child);
			child.parent = this;
		},

		getName : function()
		{
			return this.name;
		},

		getParent : function()
		{
			return this.parent;
		},

		getAttribute : function()
		{
			return this.attribute;
		},
		
		getAttributeValue : function(attrName)
		{
			if(this.attribute==null) return null;
			return this.attribute.get(attrName);
		},

		getChildren : function()
		{
			return this.children;
		},
		
		/**
		 * getChild(name);
		 * getChild(name, ignoreCase);
		 */
		getChild : function(name, ignoreCase)
		{
			if(ignoreCase==null) ignoreCase = true;
			var child = null;
			if(name!=null&&this.children!=null&&!this.children.isEmpty())
			{
				for(var i=0;i<this.children.size();i++)
				{
					var childName = this.children.get(i).getName();
					if(name==childName||(ignoreCase&&name.toLowerCase()==childName.toLowerCase()))
					{
						child = this.children.get(i);
						break;
					}
				}
			}
			return child;
		},
		
		/**
		 * getChilds(name);
		 * getChilds(name, ignoreCase);
		 */
		getChilds : function(name, ignoreCase)
		{
			if(ignoreCase==null) ignoreCase = true;
			var list = new xlsys.java.util.ArrayList();
			var child = null;
			if(name!=null&&this.children!=null&&!this.children.isEmpty())
			{
				for(var i=0;i<this.children.size();i++)
				{
					var childName = this.children.get(i).getName();
					if(name==childName||(ignoreCase&&name.toLowerCase()==childName.toLowerCase()))
					{
						child = this.children.get(i);
						list.add(child);
					}
				}
			}
			return list;
		},

		getText : function()
		{
			return this.text;
		}
	}
});