import "../../java/io/Serializable";
import "../../java/util/HashMap";
import "../../java/util/HashSet";
import "../util/ObjectUtil";
var qx = require("xlsys-qx");

/**
 * 会话类
 */
qx.Class.define("xlsys.core.session.Session",
{
	extend : xlsys.java.io.Serializable,
	
	statics : 
	{
		TYPE_WHOLE : 0,
		TYPE_INCREMENTAL : 1,
		
		DEFAULT_ID : "_DEFAULT_ID"
	},

	construct: function(sessionId)
	{
		if(sessionId==null) sessionId = this.self(arguments).DEFAULT_ID;
		this.sessionType = this.self(arguments).TYPE_WHOLE;
		this.sessionEnv = new xlsys.java.util.HashMap();
		this.tempEnv = new xlsys.java.util.HashMap();
		this.changedKeys = new xlsys.java.util.HashSet();
		this.sessionId = sessionId;
	},
	
	members :
	{
		sessionId : null,
		sessionType : null,
		sessionEnv : null,
		tempEnv : null,
		changedKeys : null,
		
		getSerializableMembers : function()
		{
			var arr = new Array();
			arr.push("sessionId");
			arr.push("sessionType");
			arr.push("sessionEnv");
			return arr;
		},
		
		setSessionId : function(sessionId)
		{
			this.sessionId = sessionId;
		},

		getSessionId : function()
		{
			return this.sessionId;
		},

		getSessionType : function()
		{
			return this.sessionType;
		},

		setSessionType : function(sessionType)
		{
			this.sessionType = sessionType;
		},

		getEnvKeySet : function()
		{
			return this.sessionEnv.keySet();
		},

		getTempEnv : function()
		{
			return this.tempEnv;
		},

		getChangedEnvKeys : function()
		{
			return this.changedKeys;
		},
		
		setAttribute : function(key, value)
		{
			// 记录session数据的修改
			var oldValue = this.sessionEnv.get(key);
			if(oldValue==value) return;
			if((oldValue!=null&&value==null)||(value!=null&&oldValue==null)) this.changedKeys.add(key);
			else if(xlsys.core.util.ObjectUtil._getHashKey(oldValue)!=xlsys.core.util.ObjectUtil._getHashKey(value)) this.changedKeys.add(key);
			this.sessionEnv.put(key, value);
		},
		
		getAttribute : function(key)
		{
			return this.sessionEnv.get(key);
		},

		setTempAttribute : function(key, value)
		{
			this.tempEnv.put(key, value);
		},

		getTempAttribute : function(key)
		{
			return this.tempEnv.get(key);
		},

		clone : function()
		{
			var cloneSession = new xlsys.core.session.Session(this.sessionId);
			cloneSession.sessionType = this.sessionType;
			cloneSession.sessionEnv.putAll(this.sessionEnv);
			cloneSession.tempEnv.putAll(this.tempEnv);
			cloneSession.changedKeys.addAll(this.changedKeys);
			return cloneSession;
		}
	}
});