require("./lib/xlsys/base/Base");
require("./lib/xlsys/base/dataset/DBStorableDataSet");
require("./lib/xlsys/base/dataset/DBSTreeDataSet");
require("./lib/xlsys/base/dataset/DBVSDataSet");
require("./lib/xlsys/base/io/net/HttpClientTransfer");
require("./lib/xlsys/base/io/net/WebClientTransfer");
require("./lib/xlsys/business/core/BusinessCore");
require("./lib/xlsys/business/core/event/FlowEvent");
require("./lib/xlsys/business/core/model/AuthorisedRightModel");
require("./lib/xlsys/business/core/model/AuthorizeDetailModel");
require("./lib/xlsys/business/core/model/AuthorizeModel");
require("./lib/xlsys/business/core/model/CodeAllocModel");
require("./lib/xlsys/business/core/model/DepartmentModel");
require("./lib/xlsys/business/core/model/DictDetailModel");
require("./lib/xlsys/business/core/model/DictModel");
require("./lib/xlsys/business/core/model/FlowCodeAllocModel");
require("./lib/xlsys/business/core/model/FlowConditionModel");
require("./lib/xlsys/business/core/model/FlowLogicModel");
require("./lib/xlsys/business/core/model/FlowModel");
require("./lib/xlsys/business/core/model/FlowRightModel");
require("./lib/xlsys/business/core/model/FlowSubTableModel");
require("./lib/xlsys/business/core/model/IdentityModel");
require("./lib/xlsys/business/core/model/IdRelationModel");
require("./lib/xlsys/business/core/model/PositionModel");
require("./lib/xlsys/business/core/model/RatifyDetailModel");
require("./lib/xlsys/business/core/model/RatifyModel");
require("./lib/xlsys/business/core/model/RightModel");
require("./lib/xlsys/business/core/model/UserModel");
require("./lib/xlsys/client/base/buffer/ClientBaseBuffer");
require("./lib/xlsys/client/base/buffer/IClientBaseBuffer");
require("./lib/xlsys/client/base/buffer/IModelBufferDelegate");
require("./lib/xlsys/client/base/buffer/MClientBaseBuffer");
require("./lib/xlsys/client/base/buffer/ModelBuffer");
require("./lib/xlsys/client/base/buffer/UnstorageBuffer");
require("./lib/xlsys/client/base/ClientBase");
require("./lib/xlsys/client/base/database/ClientDataBase");
require("./lib/xlsys/client/base/database/ClientTableInfoBuffer");
require("./lib/xlsys/client/base/io/ClientStorage");
require("./lib/xlsys/client/base/io/IClientStorage");
require("./lib/xlsys/client/base/session/SessionManager");
require("./lib/xlsys/client/base/util/ModelUtil");
require("./lib/xlsys/client/base/util/RequestUtil");
require("./lib/xlsys/client/base/util/SystemUtil");
require("./lib/xlsys/client/business/core/buffer/CBCModelBuffer");
require("./lib/xlsys/client/business/core/buffer/CBCModelBufferDelegate");
require("./lib/xlsys/client/business/core/util/CBCCommonUtil");
require("./lib/xlsys/core/buffer/BufferManager");
require("./lib/xlsys/core/buffer/EnvBuffer");
require("./lib/xlsys/core/buffer/IBuffer");
require("./lib/xlsys/core/Core");
require("./lib/xlsys/core/database/bean/ExecuteBean");
require("./lib/xlsys/core/database/bean/ISqlBean");
require("./lib/xlsys/core/database/bean/Param");
require("./lib/xlsys/core/database/bean/ParamBean");
require("./lib/xlsys/core/database/IDataBase");
require("./lib/xlsys/core/database/IEnvDataBase");
require("./lib/xlsys/core/database/TableConstraint");
require("./lib/xlsys/core/database/TableInfo");
require("./lib/xlsys/core/dataset/AbstractStorableDataSet");
require("./lib/xlsys/core/dataset/DataSet");
require("./lib/xlsys/core/dataset/DataSetCell");
require("./lib/xlsys/core/dataset/DataSetColumn");
require("./lib/xlsys/core/dataset/DataSetRow");
require("./lib/xlsys/core/dataset/IDataSet");
require("./lib/xlsys/core/dataset/IDataSetCell");
require("./lib/xlsys/core/dataset/IDataSetColumn");
require("./lib/xlsys/core/dataset/IDataSetRow");
require("./lib/xlsys/core/dataset/IStorableDataSet");
require("./lib/xlsys/core/dataset/ITreeDataSet");
require("./lib/xlsys/core/dataset/IVirtualizableDataSet");
require("./lib/xlsys/core/dataset/SortableDataSet");
require("./lib/xlsys/core/dataset/StorableDataSetColumn");
require("./lib/xlsys/core/dataset/StorableDataSetRow");
require("./lib/xlsys/core/dataset/TreeDataSet");
require("./lib/xlsys/core/dataset/VirtualizableDataSet");
require("./lib/xlsys/core/env/Environment");
require("./lib/xlsys/core/env/IConfigLoader");
require("./lib/xlsys/core/env/IEnvironment");
require("./lib/xlsys/core/event/AbstractEvent");
require("./lib/xlsys/core/event/MAsyncListener");
require("./lib/xlsys/core/io/Attachment");
require("./lib/xlsys/core/io/ByteDataInputStream");
require("./lib/xlsys/core/io/ByteDataOutputStream");
require("./lib/xlsys/core/io/net/AbstractClientTransfer");
require("./lib/xlsys/core/io/net/IClientTransfer");
require("./lib/xlsys/core/io/net/ITransfer");
require("./lib/xlsys/core/IRefreshable");
require("./lib/xlsys/core/ISortable");
require("./lib/xlsys/core/ISwapable");
require("./lib/xlsys/core/log/ConsoleLog");
require("./lib/xlsys/core/log/ILog");
require("./lib/xlsys/core/log/Log");
require("./lib/xlsys/core/model/IIndexModel");
require("./lib/xlsys/core/model/IModel");
require("./lib/xlsys/core/model/ITableModel");
require("./lib/xlsys/core/model/TreeModel");
require("./lib/xlsys/core/model/XmlModel");
require("./lib/xlsys/core/service/IPublisher");
require("./lib/xlsys/core/service/IService");
require("./lib/xlsys/core/service/ITask");
require("./lib/xlsys/core/service/ServiceManager");
require("./lib/xlsys/core/service/Task");
require("./lib/xlsys/core/service/TaskEvent");
require("./lib/xlsys/core/session/ISession");
require("./lib/xlsys/core/session/Session");
require("./lib/xlsys/core/util/IOUtil");
require("./lib/xlsys/core/util/MapUtil");
require("./lib/xlsys/core/util/NumberUtil");
require("./lib/xlsys/core/util/ObjectUtil");
require("./lib/xlsys/core/util/Pair");
require("./lib/xlsys/core/util/ReflectUtil");
require("./lib/xlsys/core/util/SqlUtil");
require("./lib/xlsys/core/util/StringUtil");
require("./lib/xlsys/core/util/Tris");
require("./lib/xlsys/java/io/Serializable");
require("./lib/xlsys/java/lang/Cloneable");
require("./lib/xlsys/java/lang/Exception");
require("./lib/xlsys/java/lang/StringBuilder");
require("./lib/xlsys/java/util/ArrayList");
require("./lib/xlsys/java/util/Collection");
require("./lib/xlsys/java/util/Entry");
require("./lib/xlsys/java/util/EventObject");
require("./lib/xlsys/java/util/HashMap");
require("./lib/xlsys/java/util/HashSet");
require("./lib/xlsys/java/util/LinkedHashMap");
require("./lib/xlsys/java/util/LinkedHashSet");
require("./lib/xlsys/java/util/List");
require("./lib/xlsys/java/util/Map");
require("./lib/xlsys/java/util/Set");
require("./lib/xlsys/java/util/SimpleEntry");
require("./lib/xlsys/java/util/StrictHashMap");
require("./lib/xlsys/java/util/StrictHashSet");
require("./lib/xlsys/java/util/StrictLinkedHashMap");
require("./lib/xlsys/java/util/StrictLinkedHashSet");

var qx = require("xlsys-qx");
var fs = require("fs");

qx.Class.define("xlsys.test.io.NodeStorage",
{
	type : "singleton",
	extend : xlsys.client.base.io.ClientStorage,
	
	statics : 
	{
		LOCAL_STORAGE_DIR : "D:/xlsysWorkDir/LOCAL_STORAGE"
	},
	
	construct : function()
	{
		this.base(arguments);
	},
	
	members : 
	{
		_mkdir : async function(path)
		{
			return new Promise(resolve=>fs.mkdir(path, resolve));
		},
		
		_writeFile : async function(path, data)
		{
			return new Promise(resolve=>fs.writeFile(path, data, "utf8", resolve));
		},
		
		_readFile : async function(path)
		{
			return new Promise((resolve, reject)=>
			{
				fs.readFile(path, "utf8", (err, data)=>
				{
					if(err) reject(err);
					else resolve(data.toString("utf8"));
				});
			});
		},
		
		setItem : async function(groupName, key, value)
		{
			let success = false;
			try
			{
				// 检查目录是否存在
				let dir = this.self(arguments).LOCAL_STORAGE_DIR;
				let exist = fs.existsSync(dir);
				if(!exist) await this._mkdir(dir);
				// 写文件是否存在
				let file = dir + "/" + groupName + "@@" + key;
				await this._writeFile(file, value);
				success = true;
			}
			catch(error)
			{
				success = false;
				xlsys.core.log.Log.getInstance().printlnError(error);
			}
			return success;
		},

		getItem : async function(groupName, key)
		{
			// 检查目录是否存在
			let dir = this.self(arguments).LOCAL_STORAGE_DIR;
			let exist = fs.existsSync(dir);
			if(!exist) return null;
			// 检查文件是否存在
			let file = dir + "/" + groupName + "@@" + key;
			exist = fs.existsSync(file);
			// 读取文件
			if(!exist) return null;
			return await this._readFile(file);
		}
	}
});

qx.Class.define("xlsys.test.io.NodeClientTransfer",
{
	extend : xlsys.base.io.net.HttpClientTransfer,
	
	construct : function()
	{
		this.base(arguments);
	},
	
	members : 
	{
		asynPost : function(inObj, callback)
		{
			var http = require("http");

			var postData = encodeURIComponent(xlsys.core.util.IOUtil.getCommonJSONFromObj(inObj));
			
			var options = {
				hostname : this.getServerIp(),
				port : this.getServerPort(),
				path : this.getPath(),
				method : "POST",
				headers : {
			          "Connection" : "keep-alive",
			          "Content-Length" : postData.length,
			          "Content-Type" : "text/plain",
			          "Host" : this.getServerIp()+":"+this.getServerPort(),
			          "User-Agent" : "Xlsys-Http/2.1"
			      }
			  }

			var req = http.request(options, qx.Bootstrap.bind(this._onResponse, this, callback));
			if(this.getTimeout()>0) req.setTimeout(this.getTimeout(), ()=>{
				callback(new Error("Request Timeout"));
			});
			req.on("error",(err)=>callback(err));
			req.write(postData);
			req.end();
		},
		
		_onResponse : function(callback, response)
		{
			var allData = "";
			response.on("data", (data)=>allData += data);
			response.on("end",()=>callback(xlsys.core.util.IOUtil.getObjFromCommonJSON(allData)));
		}
	}
});

qx.Class.define("xlsys.test.env.ConfigLoaderTest",
{
	type : "singleton",
	extend : qx.core.Object,
	implement : [xlsys.core.env.IConfigLoader],

	construct : function()
	{
		this.base(arguments);
	},
	
	members :
	{
		loadConfig : function(toEnv)
		{
			toEnv.setString(xlsys.client.base.ClientBase.ENV_STORAGE_CLASS, "xlsys.test.io.NodeStorage");
			toEnv.setString(xlsys.client.base.ClientBase.ENV_TRANSFER_CLASS, "xlsys.test.io.NodeClientTransfer");
			toEnv.setString(xlsys.client.base.ClientBase.ENV_TRANSFER_SERVERIP, "192.168.133.29");
			toEnv.setString(xlsys.client.base.ClientBase.ENV_TRANSFER_SERVERPORT, "80");
			toEnv.setString(xlsys.base.Base.ENV_REQUEST_TIME_OUT, "0");
			toEnv.setString(xlsys.client.base.ClientBase.ENV_TRANSFER_PATH, "/xlsys/ServerBaseServlet");
			toEnv.setString(xlsys.client.base.ClientBase.ENV_TRANSFER_UPLOAD_PATH, "/xlsys/UploadServlet");
			toEnv.setString(xlsys.client.base.ClientBase.ENV_TRANSFER_DOWNLOAD_PATH, "/xlsys/DownloadServlet");
			toEnv.setString(xlsys.client.base.ClientBase.ENV_ENV_ID, "2100");
			toEnv.setString(xlsys.core.Core.ENV_LOG_LEVEL, "50");
			toEnv.setString(xlsys.core.Core.ENV_LOG_CLASS, "xlsys.core.log.ConsoleLog");
		}
	}
});

qx.Class.define("xlsys.test.Test",
{
	type : "static",
	
	statics : 
	{
		test : function()
		{
			// 初始化测试系统
			this._initTestEnv();
			// 测试
			// this.requestTest();
			// this.dsAndDbTest();
			// this.sdsTest();
			// this.dbvsdsTest();
			this.testBusinessCore();
			// this.tempTest();
		},
		
		_initTestEnv : function()
	    {
	    	xlsys.core.env.Environment.setDefaultConfigLoaderClassName("xlsys.test.env.ConfigLoaderTest");
	    	xlsys.core.env.Environment.getInstance();
	    },
	    
	    requestTest : async function()
	    {
	    	let session = new xlsys.core.session.Session();
	    	session.setAttribute(xlsys.core.Core.SESSION_ENV_ID, 2100);
	    	let ret = await xlsys.client.base.util.RequestUtil.requestCommand(xlsys.base.Base.COMMAND_ALLOC_ID, session, ["xl_bc_user", "userid"]);
	    	xlsys.core.log.Log.getInstance().printlnInfo(ret);
	    },
	    
	    dsAndDbTest : async function()
	    {
	    	try
	    	{
	    		var dataBase = xlsys.client.base.database.ClientDataBase.getInstance();
	        	var dataSet = await dataBase.sqlSelect("select * from xl_bc_user");
	        	this.printDataSet(dataSet);
	    	}
	    	catch(error)
	    	{
	    		xlsys.core.log.Log.getInstance().printlnError(error);
	    	}
	    },
	    
	    printDataSet : function(dataSet)
	    {
	    	var cols = dataSet.getCols().toArray();
	    	xlsys.core.log.Log.getInstance().printlnInfo("--------cols--------");
	    	for(var i in cols)
	    	{
	    		xlsys.core.log.Log.getInstance().printlnInfo(cols[i].getColumnName());
	    	}
	    	xlsys.core.log.Log.getInstance().printlnInfo("--------rows--------");
	    	var rowCount = dataSet.getRowCount();
	    	var colCount = dataSet.getColCount();
	    	for(var i=0;i<rowCount;++i)
	    	{
	    		xlsys.core.log.Log.getInstance().printlnInfo("--------row "+i+"--------");
	    		for(var j=0;j<colCount;++j)
	    		{
	    			xlsys.core.log.Log.getInstance().printInfo(dataSet.getColName(j)+":"+dataSet.getValue(i, j) + "\t");
	    		}
	    		xlsys.core.log.Log.getInstance().printlnInfo("");
	    	}
	    },
	    
	    sdsTest : async function()
	    {
	    	var selectBean = new xlsys.core.database.bean.ParamBean("select * from xl_bc_user order by userid");
	    	var sds = new xlsys.base.dataset.DBStorableDataSet(xlsys.client.base.database.ClientDataBase.getInstance(), selectBean, "xl_bc_user");
	    	await sds.open();
	    	this.printDataSet(sds);
	    	sds.removeRow(10);
	    	sds.removeRow(5);
	    	sds.setValue(4, "name", "ttttt");
	    	sds.setValue(3, "userid", "Hello");
	    	await sds.save();
	    	this.printDataSet(sds);
	    },
	    
	    dbvsdsTest : async function()
	    {
	    	var selectBean = new xlsys.core.database.bean.ParamBean("select * from xl_bc_user order by userid");
	    	var dbvsds = new xlsys.base.dataset.DBVSDataSet(xlsys.client.base.database.ClientDataBase.getInstance(), selectBean, "xl_bc_user");
	    	await dbvsds.open();
	    	await dbvsds.expandToRow(500);
	    	var colCount = dbvsds.getColCount();
	    	for(var j=0;j<colCount;++j)
			{
	    		let value = await dbvsds.asyncGetValue(500, j);
				xlsys.core.log.Log.getInstance().printInfo(dbvsds.getColName(j)+":"+value + "\t");
			}
	    	xlsys.core.log.Log.getInstance().printlnInfo("");
	    },
	    
	    testBusinessCore : async function()
		{
			try
			{
				// 创建session
		    	let session = new xlsys.core.session.Session();
		    	session.setAttribute(xlsys.core.Core.SESSION_ENV_ID, xlsys.core.util.ObjectUtil.objectToInt(xlsys.core.env.Environment.getInstance().getString(xlsys.client.base.ClientBase.ENV_ENV_ID)));
		    	session.setAttribute(xlsys.business.core.BusinessCore.SESSION_USER_ID, xlsys.business.core.BusinessCore.DEFAULT_ADMIN_CODE);
		    	session.setAttribute(xlsys.business.core.BusinessCore.SESSION_DEPT_ID, xlsys.business.core.BusinessCore.DEFAULT_ADMIN_CODE);
		    	session.setAttribute(xlsys.business.core.BusinessCore.SESSION_PST_ID, xlsys.business.core.BusinessCore.DEFAULT_ADMIN_CODE);
		    	session.setAttribute(xlsys.business.core.BusinessCore.SESSION_IDENTITY, xlsys.business.core.BusinessCore.DEFAULT_ADMIN_CODE);
		    	xlsys.client.base.session.SessionManager.getInstance().setCurrentSession(session);
		    	// 获取可使用的操作
		    	let flowId = "0001";
		    	let innerCode = "0000000000000004";
		    	let paramMap = new xlsys.java.util.HashMap();
		    	paramMap.put("flowId", flowId);
		    	paramMap.put("innerCode", innerCode);
		    	let operationList = await xlsys.client.base.util.RequestUtil.simpleRequest(xlsys.business.core.BusinessCore.COMMAND_GET_OPERATION_DATA, paramMap);
		    	for(let i=0;i<operationList.size();++i)
		    	{
		    		let tris = operationList.get(i);
		    		let operation = tris.first;
		    		let fromCondition = tris.second;
		    		let toCondition = tris.third;
		    		xlsys.core.log.Log.getInstance().printlnInfo("operation:"+operation+"    fromCondition:"+(fromCondition==null?"":fromCondition)+"    toCondition:"+(toCondition==null?"":toCondition));
		    		// 模拟提交或审批
		    		if(xlsys.business.core.BusinessCore.BUSI_OPER_SUBMIT==operation)
		    		{
		    			// 提交
		    			let tempMap = new xlsys.java.util.HashMap();
		    			tempMap.put("flowId", flowId);
		    			tempMap.put("innerCode", innerCode);
		    			tempMap.put("fromCondition", fromCondition);
		    			tempMap.put("toCondition", toCondition);
		    			// 执行提交前命令, 获取flowEvent
		    			let flowEvent = await xlsys.client.base.util.RequestUtil.simpleRequest(xlsys.business.core.BusinessCore.COMMAND_BEFORE_SUBMIT, tempMap);
		    			flowEvent.session = session;
		    			// 模拟客户端选择要提交的人员
		    			flowEvent.selectedUsers = flowEvent.submitToUsers;
		    			// 执行提交命令
		    			let retObj = await xlsys.client.base.util.RequestUtil.simpleRequest(xlsys.business.core.BusinessCore.COMMAND_SUBMIT, flowEvent);
		    			xlsys.core.log.Log.getInstance().printlnInfo("Submit complete with return : " + retObj);
		    		}
		    		else if(xlsys.business.core.BusinessCore.BUSI_OPER_RATIFY==operation)
		    		{
		    			// 审批
		    			let tempMap = new xlsys.java.util.HashMap();
		    			tempMap.put("flowId", flowId);
		    			tempMap.put("innerCode", innerCode);
		    			tempMap.put("fromCondition", fromCondition);
		    			tempMap.put("toCondition", toCondition);
		    			// 执行审批前命令, 获取flowEvent
		    			let flowEvent = await xlsys.client.base.util.RequestUtil.simpleRequest(xlsys.business.core.BusinessCore.COMMAND_BEFORE_RATIFY, tempMap);
		    			flowEvent.session = session;
		    			// 模拟客户端写入审批相关信息
		    			flowEvent.beReplaceUser = flowEvent.submitToUsers.toArray()[0];
		    			flowEvent.rtfDescMap = new xlsys.java.util.HashMap();
		    			flowEvent.rtfDescMap.put(xlsys.business.core.BusinessCore.RTF_RET_PASS, "同意");
		    			flowEvent.rtfDescMap.put(xlsys.business.core.BusinessCore.RTF_RET_REJECT, "驳回");
		    			flowEvent.rtfRet = xlsys.business.core.BusinessCore.RTF_RET_PASS;
		    			flowEvent.rejectToCondition = "100";
		    			// 执行审批命令
		    			let retObj = await xlsys.client.base.util.RequestUtil.simpleRequest(xlsys.business.core.BusinessCore.COMMAND_RATIFY, flowEvent);
		    			xlsys.core.log.Log.getInstance().printlnInfo("Ratify complete with return : " + retObj);
		    		}
		    		else if(xlsys.business.core.BusinessCore.BUSI_OPER_VERSION_UPDATE==operation)
		    		{
		    			// 版本更新
		    			let retObj = await xlsys.client.base.util.RequestUtil.simpleRequest(xlsys.business.core.BusinessCore.COMMAND_VERSION_UPDATE, paramMap);
		    			xlsys.core.log.Log.getInstance().printlnInfo("Version update complete with return : " + retObj);
		    		}
		    	}
			}
			catch(error)
			{
				console.error(error);
			}
		},
		
		applyNew : function(clazz, args)
		{
		    var applyArgs = ([{}]).concat(args || []);
		    var f = Function.prototype.bind.apply(clazz, applyArgs);
		    return new f();
		},
		
		tempTest : async function()
		{
			let session = new xlsys.core.session.Session();
	    	session.setAttribute(xlsys.core.Core.SESSION_ENV_ID, 2100);
	    	let ret = await xlsys.client.base.util.RequestUtil.requestCommand("_FOR_TEST", session);
	    	xlsys.core.log.Log.getInstance().printlnInfo(ret);
		}
	}
});

xlsys.test.Test.test();