require("./DBStorableDataSet");require("../../core/dataset/IVirtualizableDataSet");require("../../core/dataset/DataSetRow");require("../../core/util/Pair");require("../../core/log/Log");require("../../core/util/ObjectUtil");require("../../java/util/HashMap");var regeneratorRuntime=require("regenerator-runtime");var qx=require("xlsys-qx");qx.Class.define("xlsys.base.dataset.DBVSDataSet",{extend:xlsys.base.dataset.DBStorableDataSet,implement:[xlsys.core.dataset.IVirtualizableDataSet],construct:function construct(dataBase,selectBean,tableName){this.base(arguments,dataBase,selectBean,tableName);this.expandPerCount=32;},members:{expandPerCount:null,setRowCount:function setRowCount(rowCount){var curRowCount=this.getRowCount();if(curRowCount<rowCount){this.setEventLock(true);this.setLockChange(true);var oldRowCursor=this.getRowCursor();for(var i=0;i<rowCount-curRowCount;++i){var row=this.createRow();row.setStatus(xlsys.core.dataset.DataSetRow.STATUS_VIRTUAL);}this.gotoRow(oldRowCursor);this.setEventLock(false);this.setLockChange(false);}},getExpandPerCount:function getExpandPerCount(){return this.expandPerCount;},setExpandPerCount:function setExpandPerCount(expandPerCount){this.expandPerCount=expandPerCount;},getPageRangeOfRowAt:function getPageRangeOfRowAt(wantRowAt){this.checkRowRegion(wantRowAt);var beginRowIdx=Math.floor(wantRowAt/this.expandPerCount)*this.expandPerCount;var endRowIdx=Math.min(beginRowIdx+this.expandPerCount-1,this.getRowCount()-1);return new xlsys.core.util.Pair(beginRowIdx,endRowIdx);},expandToRow:function expandToRow(wantRowAt){var range,success;return regeneratorRuntime.async(function expandToRow$(_context){while(1){switch(_context.prev=_context.next){case 0:this.checkRowRegion(wantRowAt);if(this.isVirtualRow(wantRowAt)){_context.next=3;break;}return _context.abrupt("return",true);case 3:range=this.getPageRangeOfRowAt(wantRowAt);success=false;_context.prev=5;_context.next=8;return regeneratorRuntime.awrap(this._expandRow(range.first,range.second));case 8:success=_context.sent;_context.next=15;break;case 11:_context.prev=11;_context.t0=_context["catch"](5);success=false;xlsys.core.log.Log.getInstance().printlnError(_context.t0);case 15:return _context.abrupt("return",success);case 16:case"end":return _context.stop();}}},null,this,[[5,11]]);},_expandRow:function _expandRow(beginRowAt,endRowAt){var dataSet,tempRows,i,row;return regeneratorRuntime.async(function _expandRow$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:xlsys.core.log.Log.getInstance().printlnDebug("Expand row from "+beginRowAt+" to "+endRowAt);_context2.next=3;return regeneratorRuntime.awrap(this.dataBase.sqlSelect(this.selectBean,beginRowAt,endRowAt));case 3:dataSet=_context2.sent;tempRows=dataSet.getRows();for(i=0;i<tempRows.size();++i){row=this.getRows().get(i+beginRowAt);row.cloneOf(tempRows.get(i));row.setStatus(xlsys.core.dataset.DataSetRow.STATUS_COMMON);}return _context2.abrupt("return",true);case 7:case"end":return _context2.stop();}}},null,this);},expandAllRows:function expandAllRows(){var rowCount,allPromises,i;return regeneratorRuntime.async(function expandAllRows$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:rowCount=this.getRowCount();allPromises=new Array();for(i=0;i<rowCount;i+=this.expandPerCount){allPromises.push(this.expandToRow(i));}_context3.next=5;return regeneratorRuntime.awrap(Promise.all(allPromises));case 5:return _context3.abrupt("return");case 6:case"end":return _context3.stop();}}},null,this);},isVirtualRow:function isVirtualRow(rowOrRowAt){var row=null;if(qx.lang.Type.isNumber(rowOrRowAt)){this.checkRowRegion(rowOrRowAt);row=this.getRow(rowOrRowAt);}else row=rowOrRowAt;return xlsys.core.util.ObjectUtil.hasBitProp(row.getStatus(),xlsys.core.dataset.DataSetRow.STATUS_VIRTUAL);},removeRow:function removeRow(rowOrRowAt){throw new Error("Can not use removeRow, use asyncRemoveRow instead");},asyncRemoveRow:function asyncRemoveRow(rowOrRowAt){var rowAt,row;return regeneratorRuntime.async(function asyncRemoveRow$(_context4){while(1){switch(_context4.prev=_context4.next){case 0:rowAt=null;if(qx.lang.Type.isNumber(rowOrRowAt))rowAt=rowOrRowAt;else rowAt=this.getRowAt(rowOrRowAt);this.checkRowRegion(rowAt);_context4.next=5;return regeneratorRuntime.awrap(this.expandToRow(rowAt));case 5:row=this.rows.get(rowAt);if(this.isEventLock("beforeRemoveRow")){_context4.next=10;break;}this.fireDataEvent("beforeRemoveRow",row);_context4.next=10;return regeneratorRuntime.awrap(this.fireAsyncDataEvent("beforeRemoveRow",row));case 10:this.rows.removeAt(rowAt);if(this.isEventLock("afterRemoveRow")){_context4.next=15;break;}this.fireDataEvent("afterRemoveRow",row);_context4.next=15;return regeneratorRuntime.awrap(this.fireAsyncDataEvent("afterRemoveRow",row));case 15:return _context4.abrupt("return",row);case 16:case"end":return _context4.stop();}}},null,this);},getValue:function getValue(){throw new Error("Can not use getValue, use asyncGetValue instead");},asyncGetValue:function asyncGetValue(){var rowAt,colAt,row,_args5=arguments;return regeneratorRuntime.async(function asyncGetValue$(_context5){while(1){switch(_context5.prev=_context5.next){case 0:rowAt=null;colAt=null;if(_args5.length==0){rowAt=this.rowCursor;colAt=this.colCursor;}else if(_args5.length==1){rowAt=this.rowCursor;if(qx.lang.Type.isNumber(_args5[0]))colAt=_args5[0];else colAt=this.getColAt(_args5[0]);}else{if(qx.lang.Type.isNumber(_args5[0]))rowAt=_args5[0];else rowAt=this.getRowAt(_args5[0]);if(qx.lang.Type.isNumber(_args5[1]))colAt=_args5[1];else colAt=this.getColAt(_args5[1]);}this.checkRowRegion(rowAt);this.checkColRegion(colAt);_context5.next=7;return regeneratorRuntime.awrap(this.expandToRow(rowAt));case 7:row=this.rows.get(rowAt);return _context5.abrupt("return",row.getCell(colAt).getContent());case 9:case"end":return _context5.stop();}}},null,this);},setValue:function setValue(){throw new Error("Can not use setValue, use asyncSetValue instead");},asyncSetValue:function asyncSetValue(){var rowAt,colAt,value,oldValue,dataMap,_args6=arguments;return regeneratorRuntime.async(function asyncSetValue$(_context6){while(1){switch(_context6.prev=_context6.next){case 0:rowAt=null;colAt=null;value=null;if(_args6.length==1){rowAt=this.rowCursor;colAt=this.colCursor;value=_args6[0];}else if(_args6.length==2){rowAt=this.rowCursor;if(qx.lang.Type.isNumber(_args6[0]))colAt=_args6[0];else colAt=this.getColAt(_args6[0]);value=_args6[1];}else if(_args6.length==3){if(qx.lang.Type.isNumber(_args6[0]))rowAt=_args6[0];else rowAt=this.getRowAt(_args6[0]);if(qx.lang.Type.isNumber(_args6[1]))colAt=_args6[1];else colAt=this.getColAt(_args6[1]);value=_args6[2];}this.checkRowRegion(rowAt);this.checkColRegion(colAt);_context6.next=8;return regeneratorRuntime.awrap(this.expandToRow(rowAt));case 8:oldValue=this.rows.get(rowAt).getCell(colAt).getContent();if(!(oldValue==value||oldValue!=null&&value!=null&&xlsys.core.util.ObjectUtil.hashcode(oldValue)==xlsys.core.util.ObjectUtil.hashcode(value))){_context6.next=11;break;}return _context6.abrupt("return",false);case 11:dataMap=new xlsys.java.util.HashMap();dataMap.put("rowAt",rowAt);dataMap.put("colAt",colAt);dataMap.put("oldValue",oldValue);dataMap.put("value",value);if(this.isEventLock("beforePostValue")){_context6.next=20;break;}this.fireDataEvent("beforePostValue",dataMap);_context6.next=20;return regeneratorRuntime.awrap(this.fireAsyncDataEvent("beforePostValue",dataMap));case 20:this.rows.get(rowAt).getCell(colAt).setContent(value);if(this.isEventLock("afterPostValue")){_context6.next=25;break;}this.fireDataEvent("afterPostValue",dataMap);_context6.next=25;return regeneratorRuntime.awrap(this.fireAsyncDataEvent("afterPostValue",dataMap));case 25:return _context6.abrupt("return",true);case 26:case"end":return _context6.stop();}}},null,this);},open:function open(){var dataSet,colArr,i,rowArr;return regeneratorRuntime.async(function open$(_context7){while(1){switch(_context7.prev=_context7.next){case 0:if(this.isEventLock("beforeOpen")){_context7.next=4;break;}this.fireEvent("beforeOpen");_context7.next=4;return regeneratorRuntime.awrap(this.fireAsyncEvent("beforeOpen"));case 4:_context7.prev=4;_context7.next=7;return regeneratorRuntime.awrap(this.dataBase.sqlSelect(this.selectBean,0,this.getExpandPerCount()-1));case 7:dataSet=_context7.sent;this.setLockChange(true);this.rows.clear();this.cols.clear();this.colMap.clear();this.rowCursor=-1;this.colCursor=-1;colArr=dataSet.getCols().toArray();for(i in colArr){this.addCol(colArr[i]);}this._buildColMap();rowArr=dataSet.getRows().toArray();for(i in rowArr){this.createRow().setCells(rowArr[i].getCells());}_context7.t0=this;_context7.next=22;return regeneratorRuntime.awrap(this.dataBase.getResultCount(this.selectBean));case 22:_context7.t1=_context7.sent;_context7.t0.setRowCount.call(_context7.t0,_context7.t1);this.setLockChange(false);if(this.isEventLock("afterOpen")){_context7.next=29;break;}this.fireEvent("afterOpen");_context7.next=29;return regeneratorRuntime.awrap(this.fireAsyncEvent("afterOpen"));case 29:_context7.next=38;break;case 31:_context7.prev=31;_context7.t2=_context7["catch"](4);if(this.isEventLock("openFinally")){_context7.next=37;break;}this.fireEvent("openFinally");_context7.next=37;return regeneratorRuntime.awrap(this.fireAsyncEvent("openFinally"));case 37:throw _context7.t2;case 38:if(this.isEventLock("openFinally")){_context7.next=42;break;}this.fireEvent("openFinally");_context7.next=42;return regeneratorRuntime.awrap(this.fireAsyncEvent("openFinally"));case 42:return _context7.abrupt("return");case 43:case"end":return _context7.stop();}}},null,this,[[4,31]]);}}});
//# sourceMappingURL=DBVSDataSet.js.map