require("./DataSet");require("./ITreeDataSet");require("../../java/util/LinkedHashMap");require("../ISortable");require("./SortableDataSet");require("../../java/util/ArrayList");require("../../java/util/HashSet");var regeneratorRuntime=require("regenerator-runtime");var qx=require("xlsys-qx");qx.Class.define("xlsys.core.dataset.TreeDataSet",{extend:xlsys.core.dataset.DataSet,implement:[xlsys.core.dataset.ITreeDataSet],statics:{_setTreeColumn:function _setTreeColumn(treeDataSet,colAt){var sortColMap=new xlsys.java.util.LinkedHashMap();sortColMap.put(treeDataSet.getColName(colAt),xlsys.core.ISortable.ASC);xlsys.core.dataset.SortableDataSet._sort(treeDataSet,sortColMap);return true;},_getRootRows:function _getRootRows(treeDataSet){var rootRows=new xlsys.java.util.ArrayList();var childrenSet=new xlsys.java.util.HashSet();var rowArr=treeDataSet._getFactRows().toArray();for(var i in rowArr){var row=rowArr[i];if(!childrenSet.contains(row)){rootRows.add(row);var children=treeDataSet.getAllChildren(row);if(children!=null)childrenSet.addAll(children);}}return rootRows;},_getChildren:function _getChildren(treeDataSet,rowAt){var children=new xlsys.java.util.ArrayList();var treeColAt=treeDataSet.getTreeColAt();if(treeColAt<0)return children;var rows=treeDataSet._getFactRows();var row=rows.get(rowAt);var rowStr=""+row.getCell(treeColAt).getContent();var lastStr=null;for(var i=rowAt+1;i<rows.size();++i){var otherRow=rows.get(i);var otherRowStr=""+otherRow.getCell(treeColAt).getContent();if((lastStr==null||lastStr!=null&&!qx.lang.String.startsWith(otherRowStr,lastStr))&&qx.lang.String.startsWith(otherRowStr,rowStr)&&otherRowStr.length>rowStr.length){children.add(otherRow);lastStr=otherRowStr;}else if(otherRowStr.length<=rowStr.length)break;}return children;},_getAllChildren:function _getAllChildren(treeDataSet,rowAt){var children=new xlsys.java.util.ArrayList();var treeColAt=treeDataSet.getTreeColAt();if(treeColAt<0)return children;var rows=treeDataSet._getFactRows();var row=rows.get(rowAt);var rowStr=""+row.getCell(treeColAt).getContent();for(var i=rowAt+1;i<rows.size();++i){var otherRow=rows.get(i);var otherRowStr=""+otherRow.getCell(treeColAt).getContent();if(qx.lang.String.startsWith(otherRowStr,rowStr)&&otherRowStr.length>rowStr.length)children.add(otherRow);else break;}return children;},_getParentRow:function _getParentRow(treeDataSet,rowAt){var parentRow=null;var treeColAt=treeDataSet.getTreeColAt();if(treeColAt<0)return parentRow;var rows=treeDataSet._getFactRows();var row=rows.get(rowAt);var rowStr=""+row.getCell(treeColAt).getContent();for(var i=rowAt-1;i>=0;--i){var otherRow=rows.get(i);var otherRowStr=""+otherRow.getCell(treeColAt).getContent();if(qx.lang.String.startsWith(rowStr,otherRowStr)&&otherRowStr.length<rowStr.length){parentRow=otherRow;break;}}return parentRow;},_getAllParent:function _getAllParent(treeDataSet,rowAt){var parentList=new xlsys.java.util.ArrayList();var treeColAt=treeDataSet.getTreeColAt();if(treeColAt<0)return parentList;var rows=treeDataSet._getFactRows();var row=rows.get(rowAt);var rowStr=""+row.getCell(treeColAt).getContent();for(var i=rowAt-1;i>=0;--i){var otherRow=rows.get(i);var otherRowStr=""+otherRow.getCell(treeColAt).getContent();if(qx.lang.String.startsWith(rowStr,otherRowStr)&&otherRowStr.length<rowStr.length)parentList.add(otherRow);}return parentList;}},construct:function construct(){this.base(arguments);},members:{treeColName:null,setTreeColumn:function setTreeColumn(colNameOrColAt){var treeColName=null;if(qx.lang.Type.isNumber(colNameOrColAt))treeColName=this.getColName(colNameOrColAt);else treeColName=colNameOrColAt;this.treeColName=treeColName;var colAt=this.getColAt(treeColName);this.checkColRegion(colAt);this.self(arguments)._setTreeColumn(this,colAt);},sort:function sort(){if(this.treeColName!=null)this.setTreeColumn(this.treeColName);},getTreeColumn:function getTreeColumn(){return this.treeColName;},getTreeColAt:function getTreeColAt(){return this.getColAt(this.treeColName);},getRootRows:function getRootRows(){return this.self(arguments)._getRootRows(this);},getChildren:function getChildren(rowOrRowAt){var rowAt=null;if(qx.lang.Type.isNumber(rowOrRowAt))rowAt=rowOrRowAt;else rowAt=this.getRowAt(rowOrRowAt);this.checkRowRegion(rowAt);return this.self(arguments)._getChildren(this,rowAt);},getAllChildren:function getAllChildren(rowOrRowAt){var rowAt=null;if(qx.lang.Type.isNumber(rowOrRowAt))rowAt=rowOrRowAt;else rowAt=this.getRowAt(rowOrRowAt);this.checkRowRegion(rowAt);return this.self(arguments)._getAllChildren(this,rowAt);},getParentRow:function getParentRow(rowOrRowAt){var rowAt=null;if(qx.lang.Type.isNumber(rowOrRowAt))rowAt=rowOrRowAt;else rowAt=this.getRowAt(rowOrRowAt);this.checkRowRegion(rowAt);return this.self(arguments)._getParentRow(this,rowAt);},getAllParent:function getAllParent(rowOrRowAt){var rowAt=null;if(qx.lang.Type.isNumber(rowOrRowAt))rowAt=rowOrRowAt;else rowAt=this.getRowAt(rowOrRowAt);this.checkRowRegion(rowAt);return this.self(arguments)._getAllParent(this,rowAt);},removeRow:function removeRow(rowOrRowAt,removeChildren){if(removeChildren==null)removeChildren=false;var rowAt=null;if(qx.lang.Type.isNumber(rowOrRowAt))rowAt=rowOrRowAt;else rowAt=this.getRowAt(rowOrRowAt);this.checkRowRegion(rowAt);var removedRows=new xlsys.java.util.ArrayList();if(removeChildren){var children=this.getAllChildren(rowAt);removedRows.addAll(children);for(var i=children.size()-1;i>=0;--i){this.base(arguments,children.get(i));}}removedRows.add(this.base(arguments,rowAt));if(arguments.length==1){if(removedRows.isEmpty())return null;else return removedRows.get(0);}return removedRows;},asyncRemoveRow:function asyncRemoveRow(rowOrRowAt,removeChildren){return regeneratorRuntime.async(function asyncRemoveRow$(_context){while(1){switch(_context.prev=_context.next){case 0:return _context.abrupt("return",this.removeRow(rowOrRowAt,removeChildren));case 1:case"end":return _context.stop();}}},null,this);}}});
//# sourceMappingURL=TreeDataSet.js.map