require("../../java/lang/StringBuilder");require("../io/ByteDataInputStream");require("../../java/util/HashMap");require("../Core");require("./StringUtil");require("../../java/util/SimpleEntry");require("./ObjectUtil");require("../../java/util/LinkedHashMap");require("../io/ByteDataOutputStream");require("../../java/util/Entry");require("../../java/util/Collection");require("../../java/util/Map");require("../../java/lang/Exception");require("../dataset/IDataSetRow");require("../../java/io/Serializable");require("../dataset/DataSetCell");var qx=require("xlsys-qx");qx.Class.define("xlsys.core.util.IOUtil",{type:"static",statics:{__rRegExp:new RegExp("\r","g"),__nRegExp:new RegExp("\n","g"),__tRegExp:new RegExp("\t","g"),__dqRegExp:new RegExp("\"","g"),__escapeRRegExp:new RegExp("&#13;","g"),__escapeNRegExp:new RegExp("&#10;","g"),__escapeTRegExp:new RegExp("&#09;","g"),__escapeDQRegExp:new RegExp("&#34;","g"),getDQMStr:function getDQMStr(str){return"\""+str+"\"";},createJSONAttr:function createJSONAttr(attrName,attrValue){var sb=new xlsys.java.lang.StringBuilder();sb.append("\"").append(attrName).append("\":");if(attrValue==null)sb.append("null");else if(typeof attrValue=="string")sb.append("\"").append(attrValue).append("\"");else sb.append(attrValue);return sb.toString();},readInternalObject:function readInternalObject(bytes){if(bytes==null||bytes.length==0)return null;var dis=new xlsys.core.io.ByteDataInputStream(bytes);var firstHashcode=0;var hasWriteObjMap=new xlsys.java.util.HashMap();var totalLength=dis.readInt();var totalContent=new Array(totalLength);dis.readFully(totalContent,0,totalLength);var tempDis=new xlsys.core.io.ByteDataInputStream(totalContent);while(tempDis.available()>0){var hashcode=tempDis.readInt();if(firstHashcode==0)firstHashcode=hashcode;var length=tempDis.readInt();var content=new Array(length);tempDis.readFully(content,0,length);hasWriteObjMap.put(hashcode,content);}var rebuiltObjMap=new xlsys.java.util.HashMap();return this.rebuildInternalObject(firstHashcode,hasWriteObjMap,rebuiltObjMap);},rebuildInternalObject:function rebuildInternalObject(hashcode,hasWriteObjMap,rebuiltObjMap){var obj=null;if(rebuiltObjMap.containsKey(hashcode))obj=rebuiltObjMap.get(hashcode);else{var content=hasWriteObjMap.get(hashcode);var dis=new xlsys.core.io.ByteDataInputStream(content);var type=dis.readByte();if(type==xlsys.core.Core.DATA_TYPE_NULL){}else if(type==xlsys.core.Core.DATA_TYPE_STR){var length=dis.readInt();var bytes=new Array(length);dis.readFully(bytes,0,length);obj=xlsys.core.util.StringUtil.bytesToString(bytes);}else if(type==xlsys.core.Core.DATA_TYPE_STR_ARRAY){var length=dis.readInt();obj=new Array();var bytes=new Array(length);dis.readFully(bytes,0,length);var tempIn=new xlsys.core.io.ByteDataInputStream(bytes);while(tempIn.available()>0){var tempHashcode=tempIn.readInt();obj.push(this.rebuildInternalObject(tempHashcode,hasWriteObjMap,rebuiltObjMap));}}else if(type==xlsys.core.Core.DATA_TYPE_SHORT){obj=dis.readShort();}else if(type==xlsys.core.Core.DATA_TYPE_INT){obj=dis.readInt();}else if(type==xlsys.core.Core.DATA_TYPE_LONG){obj=dis.readLong();}else if(type==xlsys.core.Core.DATA_TYPE_CHAR){obj=dis.readChar();}else if(type==xlsys.core.Core.DATA_TYPE_BOOL){obj=dis.readByte()==1?true:false;}else if(type==xlsys.core.Core.DATA_TYPE_FLOAT){throw new Error("Unsupported!");}else if(type==xlsys.core.Core.DATA_TYPE_DOUBLE){throw new Error("Unsupported!");}else if(type==xlsys.core.Core.DATA_TYPE_BYTE){obj=dis.readByte();}else if(type==xlsys.core.Core.DATA_TYPE_BYTE_ARRAY){var length=dis.readInt();var bytes=new Array(length);dis.readFully(bytes,0,length);obj=bytes;}else if(type==xlsys.core.Core.DATA_TYPE_BIGDECIMAL){var numHashcode=dis.readInt();var numStr=this.rebuildInternalObject(numHashcode,hasWriteObjMap,rebuiltObjMap);obj=Number(numStr);}else if(type==xlsys.core.Core.DATA_TYPE_DATE){var time=dis.readLong();obj=new Date(time);obj.setTime(time);}else if(type==xlsys.core.Core.DATA_TYPE_ENTRY){var length=dis.readInt();var bytes=new Array(length);dis.readFully(bytes,0,length);var tempIn=new xlsys.core.io.ByteDataInputStream(bytes);var tempHashcode=tempIn.readInt();var key=this.rebuildInternalObject(tempHashcode,hasWriteObjMap,rebuiltObjMap);tempHashcode=tempIn.readInt();var value=this.rebuildInternalObject(tempHashcode,hasWriteObjMap,rebuiltObjMap);obj=new xlsys.java.util.SimpleEntry(key,value);}else if(type==xlsys.core.Core.DATA_TYPE_ENTRY_ARRAY){var length=dis.readInt();var obj=new Array();var bytes=new Array(length);dis.readFully(bytes,0,length);var tempIn=new xlsys.core.io.ByteDataInputStream(bytes);while(tempIn.available()>0){var tempHashcode=tempIn.readInt();obj.push(this.rebuildInternalObject(tempHashcode,hasWriteObjMap,rebuiltObjMap));}}else if(type==xlsys.core.Core.DATA_TYPE_OBJECT_ARRAY){var length=dis.readInt();var obj=new Array();var bytes=new Array(length);dis.readFully(bytes,0,length);var tempIn=new xlsys.core.io.ByteDataInputStream(bytes);while(tempIn.available()>0){var tempHashcode=tempIn.readInt();obj.push(this.rebuildInternalObject(tempHashcode,hasWriteObjMap,rebuiltObjMap));}}else if(type==xlsys.core.Core.DATA_TYPE_COLLECTION){var nameHashcode=dis.readInt();var objClassName=this.rebuildInternalObject(nameHashcode,hasWriteObjMap,rebuiltObjMap);obj=xlsys.core.util.ObjectUtil.tryInitObj(objClassName);if(obj==null)throw new Error("Unsupported");rebuiltObjMap.put(hashcode,obj);var length=dis.readInt();var bytes=new Array(length);dis.readFully(bytes,0,length);var tempIn=new xlsys.core.io.ByteDataInputStream(bytes);while(tempIn.available()>0){var tempHashcode=tempIn.readInt();obj.add(this.rebuildInternalObject(tempHashcode,hasWriteObjMap,rebuiltObjMap));}}else if(type==xlsys.core.Core.DATA_TYPE_MAP){var nameHashcode=dis.readInt();var objClassName=this.rebuildInternalObject(nameHashcode,hasWriteObjMap,rebuiltObjMap);obj=xlsys.core.util.ObjectUtil.tryInitObj(objClassName);if(obj==null)throw new Error("Unsupported");rebuiltObjMap.put(hashcode,obj);var length=dis.readInt();var bytes=new Array(length);dis.readFully(bytes,0,length);var tempIn=new xlsys.core.io.ByteDataInputStream(bytes);while(tempIn.available()>0){var tempHashcode=tempIn.readInt();var key=this.rebuildInternalObject(tempHashcode,hasWriteObjMap,rebuiltObjMap);tempHashcode=tempIn.readInt();var value=this.rebuildInternalObject(tempHashcode,hasWriteObjMap,rebuiltObjMap);obj.put(key,value);}}else if(type==xlsys.core.Core.DATA_TYPE_EXCEPTION){var nameHashcode=dis.readInt();var objClassName=this.rebuildInternalObject(nameHashcode,hasWriteObjMap,rebuiltObjMap);obj=xlsys.core.util.ObjectUtil.tryInitObj(objClassName);if(obj==null)throw new Error("Unsupported");var length=dis.readInt();var bytes=new Array(length);dis.readFully(bytes,0,length);var tempIn=new xlsys.core.io.ByteDataInputStream(bytes);var fieldNameHashcode=tempIn.readInt();this.rebuildInternalObject(fieldNameHashcode,hasWriteObjMap,rebuiltObjMap);var msgHashcode=tempIn.readInt();var message=this.rebuildInternalObject(msgHashcode,hasWriteObjMap,rebuiltObjMap);fieldNameHashcode=tempIn.readInt();this.rebuildInternalObject(fieldNameHashcode,hasWriteObjMap,rebuiltObjMap);var stackTraceHashcode=tempIn.readInt();var stackTrace=this.rebuildInternalObject(stackTraceHashcode,hasWriteObjMap,rebuiltObjMap);fieldNameHashcode=tempIn.readInt();this.rebuildInternalObject(fieldNameHashcode,hasWriteObjMap,rebuiltObjMap);var causeHashcode=tempIn.readInt();var cause=this.rebuildInternalObject(causeHashcode,hasWriteObjMap,rebuiltObjMap);obj.msg=message;obj.stackTrace=stackTrace;obj.cause=cause;rebuiltObjMap.put(hashcode,obj);}else{var nameHashcode=dis.readInt();var objClassName=this.rebuildInternalObject(nameHashcode,hasWriteObjMap,rebuiltObjMap);obj=xlsys.core.util.ObjectUtil.tryInitObj(objClassName);if(obj==null)throw new Error("Unsupported");rebuiltObjMap.put(hashcode,obj);var length=dis.readInt();var bytes=new Array(length);dis.readFully(bytes,0,length);var tempIn=new xlsys.core.io.ByteDataInputStream(bytes);while(tempIn.available()>0){var fieldNameHashcode=tempIn.readInt();var fieldName=this.rebuildInternalObject(fieldNameHashcode,hasWriteObjMap,rebuiltObjMap);var tempHashcode=tempIn.readInt();var fieldObj=this.rebuildInternalObject(tempHashcode,hasWriteObjMap,rebuiltObjMap);obj[fieldName]=fieldObj;}}rebuiltObjMap.put(hashcode,obj);}return obj;},getInternalObjectBytes:function getInternalObjectBytes(obj){var hasWriteObjMap=new xlsys.java.util.LinkedHashMap();this.prepareInternalBytes(obj,hasWriteObjMap);var baos=new xlsys.core.io.ByteDataOutputStream();var keys=hasWriteObjMap.keys();for(var i=0;i<keys.length;++i){var hashcode=keys[i];baos.writeInt(hashcode);var content=hasWriteObjMap.get(hashcode);baos.writeInt(content.length);baos.write(content);}var out=new xlsys.core.io.ByteDataOutputStream();var temp=baos.toByteArray();out.writeInt(temp.length);out.write(temp);return out.toByteArray();},prepareInternalBytes:function prepareInternalBytes(obj,hasWriteObjMap,dataType){if(hasWriteObjMap.containsKey(xlsys.core.util.ObjectUtil.hashcode(obj)))return;hasWriteObjMap.put(xlsys.core.util.ObjectUtil.hashcode(obj),null);var data=null;var out=new xlsys.core.io.ByteDataOutputStream();if(obj==null){out.writeByte(xlsys.core.Core.DATA_TYPE_NULL);}else{if(dataType==null){if(qx.lang.Type.isString(obj))dataType=xlsys.core.Core.DATA_TYPE_STR;else if(qx.lang.Type.isArray(obj))dataType=xlsys.core.Core.DATA_TYPE_OBJECT_ARRAY;else if(qx.lang.Type.isNumber(obj))dataType=xlsys.core.Core.DATA_TYPE_BIGDECIMAL;else if(qx.lang.Type.isBoolean(obj))dataType=xlsys.core.Core.DATA_TYPE_BOOL;else if(qx.lang.Type.isDate(obj))dataType=xlsys.core.Core.DATA_TYPE_DATE;else if(qx.Class.implementsInterface(obj,xlsys.java.util.Entry))dataType=xlsys.core.Core.DATA_TYPE_ENTRY;else if(qx.Class.implementsInterface(obj,xlsys.java.util.Collection))dataType=xlsys.core.Core.DATA_TYPE_COLLECTION;else if(qx.Class.implementsInterface(obj,xlsys.java.util.Map))dataType=xlsys.core.Core.DATA_TYPE_MAP;else if(obj instanceof xlsys.java.lang.Exception)dataType=xlsys.core.Core.DATA_TYPE_EXCEPTION;else dataType=xlsys.core.Core.DATA_TYPE_OBJECT;}if(dataType==xlsys.core.Core.DATA_TYPE_STR){var bytes=xlsys.core.util.StringUtil.stringToBytes(obj);out.writeByte(xlsys.core.Core.DATA_TYPE_STR);out.writeInt(bytes.length);out.write(bytes);}else if(dataType==xlsys.core.Core.DATA_TYPE_SHORT){out.writeByte(xlsys.core.Core.DATA_TYPE_SHORT);out.writeShort(obj);}else if(dataType==xlsys.core.Core.DATA_TYPE_INT){out.writeByte(xlsys.core.Core.DATA_TYPE_INT);out.writeInt(obj);}else if(dataType==xlsys.core.Core.DATA_TYPE_LONG){out.writeByte(xlsys.core.Core.DATA_TYPE_LONG);out.writeLong(obj);}else if(dataType==xlsys.core.Core.DATA_TYPE_CHAR){out.writeByte(xlsys.core.Core.DATA_TYPE_CHAR);out.writeChar(obj);}else if(dataType==xlsys.core.Core.DATA_TYPE_BOOL){out.writeByte(xlsys.core.Core.DATA_TYPE_BOOL);out.writeByte(obj?1:0);}else if(dataType==xlsys.core.Core.DATA_TYPE_BYTE){out.writeByte(xlsys.core.Core.DATA_TYPE_BYTE);out.writeByte(obj);}else if(dataType==xlsys.core.Core.DATA_TYPE_BYTE_ARRAY){out.writeByte(xlsys.core.Core.DATA_TYPE_BYTE_ARRAY);out.writeInt(obj.length);out.write(obj);}else if(dataType==xlsys.core.Core.DATA_TYPE_BIGDECIMAL){out.writeByte(xlsys.core.Core.DATA_TYPE_BIGDECIMAL);var numStr=""+obj;out.writeInt(xlsys.core.util.ObjectUtil.hashcode(numStr));this.prepareInternalBytes(numStr,hasWriteObjMap);}else if(dataType==xlsys.core.Core.DATA_TYPE_DATE){out.writeByte(xlsys.core.Core.DATA_TYPE_DATE);out.writeLong(obj.getTime());}else if(dataType==xlsys.core.Core.DATA_TYPE_ENTRY){out.writeByte(xlsys.core.Core.DATA_TYPE_ENTRY);var tempOut=new xlsys.core.io.ByteDataOutputStream();var key=obj.getKey();tempOut.writeInt(xlsys.core.util.ObjectUtil.hashcode(key));this.prepareInternalBytes(key,hasWriteObjMap);var value=obj.getValue();tempOut.writeInt(xlsys.core.util.ObjectUtil.hashcode(value));this.prepareInternalBytes(value,hasWriteObjMap);var arrBytes=tempOut.toByteArray();out.writeInt(arrBytes.length);out.write(arrBytes);}else if(dataType==xlsys.core.Core.DATA_TYPE_ENTRY_ARRAY||dataType==xlsys.core.Core.DATA_TYPE_OBJECT_ARRAY||dataType==xlsys.core.Core.DATA_TYPE_STR_ARRAY){out.writeByte(dataType);var tempOut=new xlsys.core.io.ByteDataOutputStream();for(var i=0;i<obj.length;++i){var temp=obj[i];tempOut.writeInt(xlsys.core.util.ObjectUtil.hashcode(temp));this.prepareInternalBytes(temp,hasWriteObjMap);}var arrBytes=tempOut.toByteArray();out.writeInt(arrBytes.length);out.write(arrBytes);}else if(dataType==xlsys.core.Core.DATA_TYPE_COLLECTION){out.writeByte(xlsys.core.Core.DATA_TYPE_COLLECTION);var name=xlsys.core.util.ObjectUtil.className(obj);out.writeInt(xlsys.core.util.ObjectUtil.hashcode(name));this.prepareInternalBytes(name,hasWriteObjMap);var tempOut=new xlsys.core.io.ByteDataOutputStream();var collectionArr=obj.toArray();for(var i=0;i<collectionArr.length;++i){var temp=collectionArr[i];tempOut.writeInt(xlsys.core.util.ObjectUtil.hashcode(temp));this.prepareInternalBytes(temp,hasWriteObjMap);}var arrBytes=tempOut.toByteArray();out.writeInt(arrBytes.length);out.write(arrBytes);}else if(dataType==xlsys.core.Core.DATA_TYPE_MAP){out.writeByte(xlsys.core.Core.DATA_TYPE_MAP);var name=xlsys.core.util.ObjectUtil.className(obj);out.writeInt(xlsys.core.util.ObjectUtil.hashcode(name));this.prepareInternalBytes(name,hasWriteObjMap);var tempOut=new xlsys.core.io.ByteDataOutputStream();var keys=obj.keys();for(var i=0;i<keys.length;++i){var key=keys[i];var value=obj.get(key);tempOut.writeInt(xlsys.core.util.ObjectUtil.hashcode(key));this.prepareInternalBytes(key,hasWriteObjMap);tempOut.writeInt(xlsys.core.util.ObjectUtil.hashcode(value));this.prepareInternalBytes(value,hasWriteObjMap);}var arrBytes=tempOut.toByteArray();out.writeInt(arrBytes.length);out.write(arrBytes);}else if(dataType==xlsys.core.Core.DATA_TYPE_EXCEPTION){out.writeByte(xlsys.core.Core.DATA_TYPE_EXCEPTION);var name=xlsys.core.util.ObjectUtil.className(obj);out.writeInt(xlsys.core.util.ObjectUtil.hashcode(name));this.prepareInternalBytes(name,hasWriteObjMap);var tempOut=new xlsys.core.io.ByteDataOutputStream();var fieldName="msg";var message=obj.getMessage();if(message==null)message="";tempOut.writeInt(xlsys.core.util.ObjectUtil.hashcode(fieldName));this.prepareInternalBytes(fieldName,hasWriteObjMap);tempOut.writeInt(xlsys.core.util.ObjectUtil.hashcode(message));this.prepareInternalBytes(message,hasWriteObjMap);fieldName="stackTrace";var stackTrace=obj.getStackTrace();tempOut.writeInt(xlsys.core.util.ObjectUtil.hashcode(fieldName));this.prepareInternalBytes(fieldName,hasWriteObjMap);tempOut.writeInt(xlsys.core.util.ObjectUtil.hashcode(stackTrace));this.prepareInternalBytes(stackTrace,hasWriteObjMap,xlsys.core.Core.DATA_TYPE_STR_ARRAY);fieldName="cause";var cause=obj.getCause();tempOut.writeInt(xlsys.core.util.ObjectUtil.hashcode(fieldName));this.prepareInternalBytes(fieldName,hasWriteObjMap);tempOut.writeInt(xlsys.core.util.ObjectUtil.hashcode(cause));this.prepareInternalBytes(cause,hasWriteObjMap);var fieldsData=tempOut.toByteArray();out.writeInt(fieldsData.length);out.write(fieldsData);}else if(dataType==xlsys.core.Core.DATA_TYPE_OBJECT){out.writeByte(xlsys.core.Core.DATA_TYPE_OBJECT);var name=xlsys.core.util.ObjectUtil.className(obj);out.writeInt(xlsys.core.util.ObjectUtil.hashcode(name));this.prepareInternalBytes(name,hasWriteObjMap);var tempOut=new xlsys.core.io.ByteDataOutputStream();var fields=obj.getSerializableMembers();for(var i=0;i<fields.length;++i){var fieldName=fields[i];tempOut.writeInt(xlsys.core.util.ObjectUtil.hashcode(fieldName));this.prepareInternalBytes(fieldName,hasWriteObjMap);var fieldObj=obj[fieldName];tempOut.writeInt(xlsys.core.util.ObjectUtil.hashcode(fieldObj));var fieldDataType=obj.getMemberDataType(fieldName);this.prepareInternalBytes(fieldObj,hasWriteObjMap,fieldDataType);}var fieldsData=tempOut.toByteArray();out.writeInt(fieldsData.length);out.write(fieldsData);}}data=out.toByteArray();hasWriteObjMap.put(xlsys.core.util.ObjectUtil.hashcode(obj),data);},bytesToHexStr:function bytesToHexStr(bytes){var sb=new xlsys.java.lang.StringBuilder();for(var i=0;i<bytes.length;++i){var temp=bytes[i].toString(16);if(temp.length<2)temp="0"+temp;sb.append(temp);}return sb.toString();},hexStrToBytes:function hexStrToBytes(hexStr){var bytes=new Array();for(var i=0;i<hexStr.length;i+=2){bytes.push(parseInt(hexStr.substring(i,i+2),16));}return bytes;},getCommonJSONFromObj:function getCommonJSONFromObj(seriObj,dataType){var sb=new xlsys.java.lang.StringBuilder();if(seriObj==null)sb.append("null");else if(qx.lang.Type.isArray(seriObj)){if(dataType!=null&&dataType==xlsys.core.Core.DATA_TYPE_BYTE_ARRAY||seriObj.length>0&&qx.lang.Type.isNumber(seriObj[0])&&qx.lang.Type.isNumber(seriObj[seriObj.length-1])){sb.append("{");sb.append(this.createJSONAttr(xlsys.core.Core.JSON_OBJ_DATA_TYPE,xlsys.core.Core.DATA_TYPE_BYTE_ARRAY)).append(",");sb.append(this.createJSONAttr("value",this.bytesToHexStr(seriObj)));sb.append("}");}else{sb.append("[");for(var i=0;i<seriObj.length;++i){sb.append(this.getCommonJSONFromObj(seriObj[i]));if(i!=seriObj.length-1)sb.append(",");}sb.append("]");}}else if(qx.lang.Type.isBoolean(seriObj))sb.append(seriObj);else if(qx.lang.Type.isDate(seriObj)){sb.append("{");sb.append(this.createJSONAttr(xlsys.core.Core.JSON_OBJ_DATA_TYPE,xlsys.core.Core.DATA_TYPE_DATE)).append(",");sb.append(this.createJSONAttr("value",seriObj.getTime()));sb.append("}");}else if(qx.lang.Type.isError(seriObj)||seriObj instanceof xlsys.java.lang.Exception){sb.append("{");sb.append(this.createJSONAttr(xlsys.core.Core.JSON_OBJ_DATA_TYPE,xlsys.core.Core.DATA_TYPE_EXCEPTION)).append(",");if(qx.lang.Type.isError(seriObj))sb.append(this.createJSONAttr("value",seriObj.message));else sb.append(this.createJSONAttr("value",seriObj.getMessage()));sb.append("}");}else if(qx.lang.Type.isNumber(seriObj))sb.append(seriObj);else if(qx.lang.Type.isString(seriObj)){if(seriObj.indexOf("\n")>=0||seriObj.indexOf("\r")>=0||seriObj.indexOf("\t")>=0||seriObj.indexOf("\"")>=0){var temp=seriObj.replace(this.__nRegExp,"&#10;").replace(this.__rRegExp,"&#13;").replace(this.__tRegExp,"&#09;").replace(this.__dqRegExp,"&#34;");sb.append("\"").append(temp).append("\"");}else sb.append("\"").append(seriObj).append("\"");}else if(qx.Class.implementsInterface(seriObj,xlsys.java.util.Collection)){sb.append("{");sb.append(this.createJSONAttr(xlsys.core.Core.JSON_OBJ_DATA_TYPE,xlsys.core.Core.DATA_TYPE_COLLECTION)).append(",");sb.append(this.createJSONAttr(xlsys.core.Core.JSON_OBJ_CLASS,xlsys.core.util.ObjectUtil.className(seriObj))).append(",");sb.append("\"value\":").append("[");var tempArr=seriObj.toArray();for(var i=0;i<tempArr.length;++i){sb.append(this.getCommonJSONFromObj(tempArr[i]));if(i!=tempArr.length-1)sb.append(",");}sb.append("]");sb.append("}");}else if(qx.Class.implementsInterface(seriObj,xlsys.java.util.Entry)){sb.append("{");sb.append(this.createJSONAttr(xlsys.core.Core.JSON_OBJ_DATA_TYPE,xlsys.core.Core.DATA_TYPE_ENTRY)).append(",");sb.append("\"key\":").append(this.getCommonJSONFromObj(seriObj.getKey()));sb.append("\"value\":").append(this.getCommonJSONFromObj(seriObj.getValue()));sb.append("}");}else if(qx.Class.implementsInterface(seriObj,xlsys.java.util.Map)){sb.append("{");sb.append(this.createJSONAttr(xlsys.core.Core.JSON_OBJ_DATA_TYPE,xlsys.core.Core.DATA_TYPE_MAP)).append(",");sb.append(this.createJSONAttr(xlsys.core.Core.JSON_OBJ_CLASS,xlsys.core.util.ObjectUtil.className(seriObj))).append(",");sb.append("\"value\":").append("[");var keyArr=seriObj.keys();for(var i=0;i<keyArr.length;++i){sb.append(this.getCommonJSONFromObj(keyArr[i])).append(",");sb.append(this.getCommonJSONFromObj(seriObj.get(keyArr[i])));if(i!=keyArr.length-1)sb.append(",");}sb.append("]");sb.append("}");}else if(qx.Class.implementsInterface(seriObj,xlsys.core.dataset.IDataSetRow)){sb.append("{");sb.append(this.createJSONAttr(xlsys.core.Core.JSON_OBJ_DATA_TYPE,xlsys.core.Core.DATA_TYPE_DATA_SET_ROW)).append(",");sb.append(this.createJSONAttr(xlsys.core.Core.JSON_OBJ_CLASS,xlsys.core.util.ObjectUtil.className(seriObj))).append(",");sb.append("\"value\":").append("[");var cellArr=seriObj.getCells().toArray();for(var i=0;i<cellArr.length;++i){sb.append(this.getCommonJSONFromObj(cellArr[i].getContent()));if(i!=cellArr.length-1)sb.append(",");}sb.append("]");sb.append("}");}else if(seriObj instanceof xlsys.java.io.Serializable){sb.append("{");sb.append(this.createJSONAttr(xlsys.core.Core.JSON_OBJ_DATA_TYPE,xlsys.core.Core.DATA_TYPE_OBJECT)).append(",");sb.append(this.createJSONAttr(xlsys.core.Core.JSON_OBJ_CLASS,xlsys.core.util.ObjectUtil.className(seriObj))).append(",");var fields=seriObj.getSerializableMembers();for(var i=0;i<fields.length;++i){var fieldName=fields[i];var fieldDataType=seriObj.getMemberDataType(fieldName);sb.append("\"").append(fieldName).append("\"").append(":").append(this.getCommonJSONFromObj(seriObj[fieldName],fieldDataType));if(i!=fields.length-1)sb.append(",");}sb.append("}");}return sb.toString();},getObjFromCommonJSON:function getObjFromCommonJSON(jsonStr){var allJson=JSON.parse(jsonStr);return this._rebuildObjFromCommonJSON(allJson);},_rebuildObjFromCommonJSON:function _rebuildObjFromCommonJSON(jsonObj){var obj=null;if(jsonObj==null)obj=null;if(qx.lang.Type.isArray(jsonObj)){obj=new Array();for(var i=0;i<jsonObj.length;++i){obj.push(this._rebuildObjFromCommonJSON(jsonObj[i]));}}else if(qx.lang.Type.isBoolean(jsonObj))obj=jsonObj;else if(qx.lang.Type.isNumber(jsonObj))obj=jsonObj;else if(qx.lang.Type.isString(jsonObj)){obj=jsonObj;obj=obj.replace(this.__escapeNRegExp,"\n").replace(this.__escapeRRegExp,"\r").replace(this.__escapeTRegExp,"\t").replace(this.__escapeDQRegExp,"\"");}else if(qx.lang.Type.isObject(jsonObj)){var dataType=jsonObj[xlsys.core.Core.JSON_OBJ_DATA_TYPE];var className=jsonObj[xlsys.core.Core.JSON_OBJ_CLASS];if(dataType==xlsys.core.Core.DATA_TYPE_DATE){obj=new Date();obj.setTime(jsonObj["value"]);}else if(dataType==xlsys.core.Core.DATA_TYPE_EXCEPTION){obj=new xlsys.java.lang.Exception(jsonObj["value"]);}else if(dataType==xlsys.core.Core.DATA_TYPE_COLLECTION){obj=xlsys.core.util.ObjectUtil.tryInitObj(className);if(obj==null)throw new Error("Unsupported");var contentJsonArr=jsonObj["value"];for(var i=0;i<contentJsonArr.length;++i){obj.add(this._rebuildObjFromCommonJSON(contentJsonArr[i]));}}else if(dataType==xlsys.core.Core.DATA_TYPE_ENTRY){var key=this._rebuildObjFromCommonJSON(jsonObj["key"]);var value=this._rebuildObjFromCommonJSON(jsonObj["value"]);obj=new xlsys.java.util.SimpleEntry(key,value);}else if(dataType==xlsys.core.Core.DATA_TYPE_MAP){obj=xlsys.core.util.ObjectUtil.tryInitObj(className);if(obj==null)throw new Error("Unsupported");var contentJsonArr=jsonObj["value"];for(var i=0;i<contentJsonArr.length;i+=2){var key=this._rebuildObjFromCommonJSON(contentJsonArr[i]);var value=this._rebuildObjFromCommonJSON(contentJsonArr[i+1]);obj.put(key,value);}}else if(dataType==xlsys.core.Core.DATA_TYPE_BYTE_ARRAY){var hexStr=jsonObj["value"];obj=this.hexStrToBytes(hexStr);}else if(dataType==xlsys.core.Core.DATA_TYPE_DATA_SET_ROW){var row=xlsys.core.util.ObjectUtil.tryInitObj(className);var contentJsonArr=jsonObj["value"];for(var i=0;i<contentJsonArr.length;++i){var dsc=new xlsys.core.dataset.DataSetCell();dsc.setContent(this._rebuildObjFromCommonJSON(contentJsonArr[i]));row.getCells().add(dsc);}obj=row;}else if(dataType==xlsys.core.Core.DATA_TYPE_OBJECT){obj=xlsys.core.util.ObjectUtil.tryInitObj(className);if(obj==null)throw new Error("Unsupported");var fields=obj.getSerializableMembers();for(var i=0;i<fields.length;++i){var fieldName=fields[i];obj[fieldName]=this._rebuildObjFromCommonJSON(jsonObj[fieldName]);}}}return obj;}}});
//# sourceMappingURL=IOUtil.js.map